/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function ProgressBar(sId, sProgressBarDomId, sProgressIndicatorDomId)
{
  if (sId) { this.init(sId, sProgressBarDomId, sProgressIndicatorDomId); }
}
ProgressBar.prototype.init = function(sId, sProgressBarDomId, sProgressIndicatorDomId)
{
  ;   
  this.sId = sId;
  this.nMaxWidth = null;
  this.nMin = 0;
  this.nMax = 100;
  this.nValue = false;
  this.bActive = true;
  this.nBlinkTimer = null;
  this.nBlinkInterval = null;
  this.bVisible = true;
  this.oProgressBar = document.getElementById(sProgressBarDomId);
  this.sProgressBarDomId = sProgressBarDomId;
  if (this.oProgressBar == null)
  {
      ;
  }
  this.oProgressIndicator = document.getElementById(sProgressIndicatorDomId);
  this.sProgressIndicatorDomId = sProgressIndicatorDomId;
  if (this.oProgressIndicator == null)
  {
      ;
  }
  this.nMaxWidth = parseInt(this.getWidthByDomID(sProgressBarDomId));
}
ProgressBar.prototype.getWidthByDomID = function(sDomId)
{
  var actualwdith = 0;
  var node = Browser.getElementById(sDomId);
  if (! actualwdith)
  {
    actualwdith = parseInt(Browser.getComputedStyleById(sDomId, 'width'));
  }
  if (! actualwdith)
  {
    if(node.width)
    {
      actualwdith =  parseInt(node.width);  
    }
  }
  if (! actualwdith)
  {
    if(node.style.width)
    {
      actualwdith =  parseInt(node.style.width);  
    }
  }
  return actualwdith;
}
ProgressBar.prototype.getId = function()
{
  //;
  return this.sId;
}
ProgressBar.prototype.setBlinkInterval = function(nBlinkInterval)
{
  //;
  var bSet = false;
  if ( nBlinkInterval && parseInt(nBlinkInterval))
  {
    this.nBlinkInterval = nBlinkInterval;
    var bSet = true;
  }
  else
  {
    ;
  }
  return bSet;
}
ProgressBar.prototype.setMin = function(nMin)
{
  //;
  var bSet = false;
  if ( nMin && parseInt(nMin) && parseInt(nMin) < this.nMax)
  {
    this.nMin = parseInt(nMin);
    this.refreshView();
    var bSet = true;
  }
  else
  {
    ;
    this.nMin = 0;
  }
  return bSet;
}
ProgressBar.prototype.setMax = function(nMax)
{
  //;
  var bSet = false;
  if ( nMax && parseInt(nMax) && parseInt(nMax) > this.nMin)
  {
    this.nMax = parseInt(nMax);
    this.refreshView();
    var bSet = true;
  }
  else
  {
    this.nMax = this.nMin;
    ;
  }
  return bSet;
}
ProgressBar.prototype.setMinAndMax = function(nMin, nMax)
{
  //;
  var bSet = false;
  if ( nMin && parseInt(nMin) )
  {
    this.nMin = nMin;
  }
  else
  {
    this.nMin = 0;
  }
  if ( nMax && parseInt(nMax) && parseInt(nMax) > this.nMin )
  {
    this.nMax = parseInt(nMax);
    this.refreshView();
    var bSet = true;
  }
  else
  {
    ;
    this.nMax = 0;
  }
  return bSet;
}
ProgressBar.prototype.setValue = function(nValue)
{
  //;
  var bSet = false;
  if ( nValue && parseInt(nValue))
  {
    if ( this.nMin <= parseInt(nValue) && parseInt(nValue) <= this.nMax )
    {
      this.nValue = parseInt(nValue);
    }
    else
    {
      if ( this.nMax < parseInt(nValue) )
      {
        this.nValue = this.nMax;
      }
      if ( this.nMin > parseInt(nValue) )
      {
        this.nValue = this.nMin;
      }
    }
  }
  else
  {
    this.nValue = 0;
  }
  this.refreshView();
  var bSet = true;
}
ProgressBar.prototype.doBlink = function(bBlink)
{
  //;
  if ( this.nBlinkInterval)
  {
    if ( ! this.bBlink )
    {
      if ( bBlink )
      {
        Browser.changePixelStyle(this.oProgressIndicator, 'width', this.nMaxWidth);
        this.bBlink = bBlink;
        this.refreshView();
      }
    }
    this.bBlink = bBlink;
  }
  else
  {
    ;
  }
}
ProgressBar.prototype.refreshView = function()
{
  //;
  if ( ! this.bBlink )
  {
    if ( this.nBlinkTimer )
    {
      window.clearInterval(this.nBlinkTimer);
      this.nBlinkTimer = null;
    }
    var nPercent = 0;
    if(this.nValue >= this.nMin)
    {
      nPercent =  ( this.nValue - this.nMin ) / ( this.nMax - this.nMin );
    }
    Browser.changePixelStyle(this.oProgressIndicator, 'width', this.nMaxWidth * nPercent);
  }
  else
  {
    var me = this;
    showHideWidgetCallback = function()
    {
      me.refreshView();
    }
    if ( this.bVisible )
    {
      this.oProgressIndicator.style.visibility = 'hidden';
      this.bVisible = false;
    }
    else
    {
      this.oProgressIndicator.style.visibility = 'visible';
      this.bVisible = true;
    }
    if ( ! this.nBlinkTimer )
    {
      this.nBlinkTimer = window.setInterval('showHideWidgetCallback()', this.nBlinkInterval);
    }
  }
}
ProgressBar.prototype.getMax = function()
{
  //;
  return this.nMax;
}
ProgressBar.prototype.getMin = function()
{
  //;
  return this.nMin;
}
ProgressBar.prototype.getValue = function()
{
  //;
  return this.nValue;
}
ProgressBar.prototype.setActive = function(bActive)
{
  //;
  if ( bActive )
  {
    this.oProgressIndicator.style.visibility = 'visible';
  }
  else
  {
    this.oProgressIndicator.style.visibility = 'hidden';
  }
  this.bActive = bActive;
}
ProgressBar.prototype.getSetMaxAction = function(nMax)
{
    return new ObjectMethodAction(this, "setMax", nMax);
}
ProgressBar.prototype.getSetMinAction = function(nMin)
{
    return new ObjectMethodAction(this, "setMin", nMin);
}
ProgressBar.prototype.getSetMinAndMaxAction = function(nMin, nMax)
{
    return new ObjectMethodAction(this, "setMinAndMax", nMin, nMax);
}
ProgressBar.prototype.getSetValueAction = function(nValue)
{
    return new ObjectMethodAction(this, "setValue", nValue);
}
ProgressBar.prototype.getSetActiveAction = function(bActive)
{
    return new ObjectMethodAction(this, "setActive", bActive);
}
