/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
</DEPENDENCIES>
*/
ScrollArea.prototype = new DomletCtr();
ScrollArea.prototype.constructor = ScrollArea;
ScrollArea.superclass = DomletCtr.prototype;
function ScrollArea( sId, sWidgetDomId )
{
  if( sId )
  {
    this.init(sId, sWidgetDomId);
  }
}
ScrollArea.prototype.init = function( sId, sWidgetDomId )
{
  ;
  ScrollArea.superclass.init.call(this, sWidgetDomId, sId, null);
  this.scrollBroker = null;
  this.sId = sId;
  this.sWidgetDomId = sWidgetDomId;
  this.oWidget = Browser.getElementById(sWidgetDomId);
  if( ! this.oWidget )
  {
    ;
  }
  this.oWidget.scrollTop = 0;
  this.minScrollStep = 4;
  this.initialScrollStep = 10;
  this.scrollStep = this.initialScrollStep;
  this.defaultScrollInterval = 20;
  this.externalScrollOffset = 0;
  this.scrollDirection = '';
  this.isScrolling = false;
  this.scrollToDistanceFromSizerBottom = 10;
  this.scrollToDistanceFromSizerTop = 10;
  this.aAreaOverflownHandles = new Array();
  this.aPositionChangeHandles = new Array();
  this.aSizeChangeHandles = new Array();
  var me = this;
  if( Browser.getId() == 'ie' )
  {
    var callback = function( event )
    {
      me.mouseWheelRollingDetectedIE(event)
    };
    Browser.addEventListenerToDomNode(this.oWidget, Browser.eventNames.MOUSEWHEEL, callback);
  }
  else
  {
    var callback = function( event )
    {
      me.mouseWheelRollingDetected(event)
    };
    Browser.addEventListenerToDomNode(this.oWidget, Browser.eventNames.MOUSEWHEEL, callback);
  }
}
ScrollArea.prototype.mouseWheelRollingDetected = function( evt )
{
  ;
  var wheelDelta = evt.detail * 4;
  if( wheelDelta > 0 )
  {
    this.scrollDirection = 'down';
    this.scrollStep = wheelDelta;
    if( !this.isScrolling )
      this.beginScroll();
  }
  else
  {
    this.scrollDirection = 'up';
    this.scrollStep = -1 * wheelDelta;
    if( !this.isScrolling )
      this.beginScroll();
  }
  this.doScroll();
  this.endScroll();
}
ScrollArea.prototype.mouseWheelRollingDetectedIE = function( evt )
{
  ;
  var wheelDelta = evt.wheelDelta / 4;
  if( wheelDelta > 0 )
  {
    this.scrollDirection = 'up';
    this.scrollStep = wheelDelta;
    if( !this.isScrolling )
      this.beginScroll();
  }
  else
  {
    this.scrollDirection = 'down';
    this.scrollStep = -1 * wheelDelta;
    if( !this.isScrolling )
      this.beginScroll();
  }
  this.doScroll();
  this.endScroll();
}
ScrollArea.prototype.getId = function()
{
  return this.sId;
}
ScrollArea.prototype.start = function()
{
  ;
  ;
  this.notifyAreaOverflow();
  this.notifyPositionChange();
  this.notifySizeChange();
}
ScrollArea.prototype.notifyAreaOverflow = function()
{
  if( this.oWidget.scrollHeight > this.oWidget.offsetHeight )
  {
    if( this.scrollBroker )
      this.scrollBroker.areaOverflow();
    ScrollArea.notifyListeners(this.aAreaOverflownHandles);
  }
}
ScrollArea.prototype.addAreaOverflownHandle = function( action )
{
  ;
  if( action )
    this.aAreaOverflownHandles.push(action);
}
ScrollArea.prototype.notifyPositionChange = function()
{
  var position = this.oWidget.scrollTop / this.oWidget.scrollHeight;
  if( this.scrollBroker )
    this.scrollBroker.positionChanged(position);
  ScrollArea.notifyListeners(this.aPositionChangeHandles, position);
}
ScrollArea.prototype.addPositionChangedHandle = function( action )
{
  ;
  if( action )
    this.aPositionChangeHandles.push(action);
}
ScrollArea.prototype.notifySizeChange = function()
{
  var size = this.oWidget.scrollHeight > this.oWidget.offsetHeight
          ? this.oWidget.offsetHeight / this.oWidget.scrollHeight : 1.0;
  if( this.scrollBroker )
    this.scrollBroker.sizeChanged(size);
  ScrollArea.notifyListeners(this.aSizeChangeHandles, size);
}
ScrollArea.prototype.addSizeChangedHandle = function( action )
{
  ;
  if( action )
    this.aSizeChangeHandles.push(action);
}
ScrollArea.notifyListeners = function( handles, param )
{
  for( var i = 0; i < handles.length; i++ )
  {
    handles[i].invoke(param);
  }
}
ScrollArea.prototype.scrollToRelativePosition = function( position )
{
  ;
  if( this.oWidget.scrollHeight > this.oWidget.offsetHeight )
  {
    if( position <= 0.0 )
    {
      this.jumpToTop();
    }
    else if( position >= 1.0 )
    {
      this.jumpToBottom()
    }
    else
    {
      var scrollTopPos = this.oWidget.scrollHeight * position;
      if( scrollTopPos + this.oWidget.offsetHeight > this.oWidget.scrollHeight )
        scrollTopPos = this.oWidget.scrollHeight - this.oWidget.offsetHeight;
      this.oWidget.scrollTop = Math.round(scrollTopPos);
    }
  }
}
ScrollArea.prototype.scrollTo = function( domId )
{
  ;
  var targetElem = document.getElementById(domId);
  if( targetElem != null )
  {
    var targetTop = targetElem.offsetTop;
    var targetBottom = targetElem.offsetTop + targetElem.offsetHeight;
    if( targetTop < this.oWidget.scrollTop + this.scrollToDistanceFromSizerTop )
    {
      this.externalScrollOffset = targetTop - this.oWidget.scrollTop - this.scrollToDistanceFromSizerTop;
    }
    var test = this.oWidget.scrollTop + this.oWidget.offsetHeight - this.scrollToDistanceFromSizerBottom;
    if( targetBottom > this.oWidget.scrollTop + this.oWidget.offsetHeight - this.scrollToDistanceFromSizerBottom )
    {
      this.externalScrollOffset = targetBottom - this.oWidget.scrollTop - this.oWidget.offsetHeight
              + this.scrollToDistanceFromSizerBottom;
    }
    //;
    if( this.oWidget.scrollTop + this.externalScrollOffset < 0 )
    {
      this.externalScrollOffset = - this.oWidget.scrollTop;
    }
    if( this.oWidget.scrollTop + this.externalScrollOffset > this.oWidget.scrollHeight - this.oWidget.offsetHeight )
    {
      this.externalScrollOffset = this.oWidget.scrollHeight - this.oWidget.offsetHeight - this.oWidget.scrollTop;
    }
    //;
    if( this.externalScrollOffset != 0 )
    {
      if( this.scrollTimer != null )
        window.clearInterval(this.scrollTimer);
      var thisScrollArea = this;
      var callback = function()
      {
        thisScrollArea.doScroll();
      };
      this.scrollTimer = window.setInterval(callback, 10);
    }
    return;
  }
}
ScrollArea.prototype.scrollToDomId = function( domId )
{
  ;
  var targetElem = document.getElementById(domId);
  if( targetElem != null )
  {
    this.scrollTo(domId);
  }
  else
  {
    ;
  }
}
ScrollArea.prototype.scrollToDomletCtr = function( oDomletCtr )
{
  ;
  if( oDomletCtr.domId != null )
  {
    this.scrollTo(oDomletCtr.domId);
  }
  else
  {
    ;
  }
}
ScrollArea.prototype.doScroll = function()
{
  ;
  ;
  var offset = 0;
  if( this.externalScrollOffset > 0 )
  {
    offset = Math.round(this.externalScrollOffset / 10);
    if( offset < this.minScrollStep ) offset = this.minScrollStep;
    this.externalScrollOffset -= offset;
    if( this.externalScrollOffset <= 0 )
    {
      this.endScroll();
      offset -= this.externalScrollOffset;
      this.externalScrollOffset = 0;
    }
    this.oWidget.scrollTop += offset;
    this.notifyPositionChange();
    this.notifySizeChange();
  }
  else if( this.externalScrollOffset < 0 )
  {
    offset = Math.round(this.externalScrollOffset / 10);
    if( offset > -this.minScrollStep ) offset = -this.minScrollStep;
    this.externalScrollOffset -= offset;
    if( this.externalScrollOffset >= 0 )
    {
      this.endScroll();
      offset -= this.externalScrollOffset;
      this.externalScrollOffset = 0;
    }
    this.oWidget.scrollTop += offset;
    this.notifyPositionChange();
    this.notifySizeChange();
  }
  else
  {
    if( this.scrollDirection == 'up' )
    {
      if( this.oWidget.scrollTop - this.scrollStep < 0 )
      {
        this.oWidget.scrollTop = 0;
        this.notifyPositionChange();
        this.notifySizeChange();
      }
      else
      {
        this.oWidget.scrollTop -= this.scrollStep;
        this.notifyPositionChange();
        this.notifySizeChange();
      }
    }
    else if( this.scrollDirection == 'down' )
    {
      if( this.oWidget.scrollTop + this.scrollStep > this.oWidget.scrollHeight - this.oWidget.offsetHeight )
      {
        this.oWidget.scrollTop = this.oWidget.scrollHeight - this.oWidget.offsetHeight;
        this.notifyPositionChange();
        this.notifySizeChange();
      }
      else
      {
        this.oWidget.scrollTop += this.scrollStep;
        this.notifyPositionChange();
        this.notifySizeChange();
      }
    }
  }
}
ScrollArea.prototype.jumpToTop = function()
{
  this.oWidget.scrollTop = 0;
  this.notifyPositionChange();
  this.notifySizeChange();
}
ScrollArea.prototype.jumpToBottom = function()
{
  this.oWidget.scrollTop = this.oWidget.scrollHeight - this.oWidget.offsetHeight;
  this.notifyPositionChange();
  this.notifySizeChange();
}
ScrollArea.prototype.beginScroll = function()
{
  //;
  this.isScrolling = true;
  if( this.scrollTimer != null )
    window.clearInterval(this.scrollTimer);
  var thisScrollArea = this;
  var callback = function()
  {
    thisScrollArea.doScroll();
  };
  this.scrollTimer = window.setInterval(callback, this.defaultScrollInterval);
}
ScrollArea.prototype.endScroll = function()
{
  //;
  this.isScrolling = false;
  this.scrollStep = this.initialScrollStep;
  if( this.scrollTimer != null )
    window.clearInterval(this.scrollTimer);
}
ScrollArea.prototype.beginScrollUp = function()
{
  //;
  this.scrollDirection = 'up';
  this.externalScrollOffset = 0;
  this.beginScroll();
}
ScrollArea.prototype.endScrollUp = function()
{
  //;
  this.endScroll();
}
ScrollArea.prototype.beginScrollDown = function()
{
  //;
  this.scrollDirection = 'down';
  this.externalScrollOffset = 0;
  this.beginScroll();
}
ScrollArea.prototype.endScrollDown = function()
{
  //;
  this.endScroll();
}
ScrollArea.prototype.getJumpToTopAction = function()
{
  return new ObjectMethodAction(this, "jumpToTop");
}
ScrollArea.prototype.getJumpToBottomAction = function()
{
  return new ObjectMethodAction(this, "jumpToBottom");
}
ScrollArea.prototype.getBeginScrollUpAction = function()
{
  return new ObjectMethodAction(this, "beginScrollUp");
}
ScrollArea.prototype.getEndScrollUpAction = function()
{
  return new ObjectMethodAction(this, "endScrollUp");
}
ScrollArea.prototype.getBeginScrollDownAction = function()
{
  return new ObjectMethodAction(this, "beginScrollDown");
}
ScrollArea.prototype.getEndScrollDownAction = function()
{
  return new ObjectMethodAction(this, "endScrollDown");
}
ScrollArea.prototype.getScrollToRelativePositionAction = function( position )
{
  return new ObjectMethodAction(this, "scrollToRelativePosition", position);
}
ScrollArea.prototype.getScrollToDomIdAction = function( domId )
{
  return new ObjectMethodAction(this, "scrollToDomId", domId);
}
ScrollArea.prototype.getScrollToDomletCtrAction = function( domletCtrl )
{
  return new ObjectMethodAction(this, "scrollToDomletCtr", domletCtrl);
}
ScrollArea.prototype.setScrollBroker = function( scrollBroker )
{
  this.scrollBroker = scrollBroker;
  this.scrollBroker.addBeginScrollDownHandle(this.getBeginScrollDownAction());
  this.scrollBroker.addEndScrollDownHandle(this.getEndScrollDownAction());
  this.scrollBroker.addBeginScrollUpHandle(this.getBeginScrollUpAction());
  this.scrollBroker.addEndScrollUpHandle(this.getEndScrollUpAction());
  this.scrollBroker.addScrollToRelativePositionHandle(this.getScrollToRelativePositionAction());
  this.scrollBroker.addScrollToDomIdHandle(this.getScrollToDomIdAction());
  this.scrollBroker.addScrollToDomletCtrHandle(this.getScrollToDomletCtrAction());
  this.scrollBroker.addJumpToTopHandle(this.getJumpToTopAction());
  this.scrollBroker.addJumpToBottomHandle(this.getJumpToBottomAction());
}
