/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
SimpleCheckbox.prototype             = new DomletCtr();
SimpleCheckbox.prototype.constructor = SimpleCheckbox;
SimpleCheckbox.superclass            = DomletCtr.prototype;
function SimpleCheckbox(domId, imgNorm, imgCheck, imgTip, imgDisabled, enabled, name, parent)
{
    ;
    if (domId) 
    {
        this.init(domId, imgNorm, imgCheck, imgTip, imgDisabled, enabled, name, parent);
    }
} 
SimpleCheckbox.prototype.init = function(domId, imgNorm, imgCheck, imgTip, imgDisabled, enabled, name, parent)
{
    SimpleCheckbox.superclass.init.call(this, domId, name, parent);
    ;
    this.state = {
        pressed : false,       
        enabled : enabled,       
        tip     : false,       
        images : {
            normal   : imgNorm,
            checked  : imgCheck,
            tip      : imgTip,
            disabled : imgDisabled
        }
    };
    ;
    this.addDomlet(new Domlet(
        this.domId,     
        this.name,      
        this.parent,    
        new Array(      
            'click'
        )
    ));
    if(this.state.enabled)
      this.setStatus('enable');
    else
      this.setStatus('disable');
    ;
} 
SimpleCheckbox.prototype.setCheckedAction = function(action)
{
    this.checkedAction = action;
}
SimpleCheckbox.prototype.setUncheckedAction = function(action)
{
    this.uncheckedAction = action;
}
SimpleCheckbox.prototype.getCheckAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "check");
}
SimpleCheckbox.prototype.getUncheckAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "uncheck");
}
SimpleCheckbox.prototype.getTipAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "tip");
}
SimpleCheckbox.prototype.getDisableAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "disable");
}
SimpleCheckbox.prototype.getEnableAction = function()
{
    return new ObjectMethodAction(this, "setStatus", "enable");
}
SimpleCheckbox.prototype.setStatus = function(status)
{
    ;
    switch (status)
    {
        case "check":
            this.state.pressed = true;
            this.state.tip = false;
            break;
        case "uncheck":
            this.state.pressed = false;
            this.state.tip = false;
            break;
        case "tip":
            this.state.pressed = true;
            this.state.tip = true;
            break;
        case "disable":
            this.state.enabled = false;
            break;
        case "enable":
            this.state.enabled = true;
            break;
    }
    this.displayState(this.name);
}
SimpleCheckbox.prototype.eventFromChild = function(childName, eventType)
{
    ;
    this.state.eventProcessed = false;
    switch(eventType)
    {
        case "click" :
            if (this.state.enabled)
            {
                this.state.pressed = !this.state.pressed;
                ;
                this.displayState(childName);
                if (this.state.pressed)
                {
                    this.eventFromChild(this.name, "checked");
                    if (this.checkedAction)
                    {
                        ;
                        this.checkedAction.invoke();
                    }
                }
                else
                {
                    this.eventFromChild(this.name, "unchecked");
                    if (this.uncheckedAction)
                    {
                        ;
                        this.uncheckedAction.invoke();
                    }
                }
            }
        break;
    }
} 
SimpleCheckbox.prototype.displayState = function(domletName)
{
    var imgSrc;
    if (this.state.pressed)
    {
        imgSrc = (this.state.tip ? this.state.images.tip : this.state.images.checked);
    }
    else
    {
        imgSrc = this.state.images.normal;
    }
    if (!this.state.enabled && !this.state.tip) 
    {
        imgSrc = this.state.images.disabled; 
    }
    if (imgSrc) 
    {
        ;
        this.domlets[domletName].setImageSource(imgSrc);
    }
} 
