/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ValueMap</DEPENDS>
    <DEPENDS>Controller</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
</DEPENDENCIES>
*/
FormInputAdapter.prototype = new DomletCtr();
FormInputAdapter.prototype.constructor = FormInputAdapter;
FormInputAdapter.superclass = DomletCtr.prototype;
function FormInputAdapter(sId, sInputWidgetDomId, emptyPossible)
{
	if (sId)
	{
		this.init(sId, sInputWidgetDomId, emptyPossible);
	}
}
FormInputAdapter.prototype.init = function(sId, sInputWidgetDomId, emptyPossible)
{
	;
	this.sId = sId;
	this.emptyPossible = emptyPossible;
	FormInputAdapter.superclass.init.call(this, sInputWidgetDomId, this.sId, this);
	this.blurActions = new Array();
	this.submitActions = new Array();
	this.valueChangedActions = new Array();
	this.activateSubmitActions = new Array();
	this.deactivateSubmitActions = new Array();
	this.initialString = null;
	this.inputWidget = document.getElementById(sInputWidgetDomId);
	this.sInputWidgetDomId = sInputWidgetDomId;
	if (this.inputWidget == null)
	{
		;
	}
	this.addDomlet(new Domlet(
			this.sInputWidgetDomId, 
			this.sInputWidgetDomId, 
			this, 
			new Array('blur', 'keyup')))	 
}
FormInputAdapter.prototype.getId = function()
{
	;
	return this.sId;
}
FormInputAdapter.prototype.registerBlurAction = function(blurAction)
{
	;
	this.blurActions.push(blurAction);
}
FormInputAdapter.prototype.registerSubmitAction = function(submitAction)
{
	;
	this.submitActions.push(submitAction);
}
FormInputAdapter.prototype.registerValueChangedAction = function(valueChangedAction)
{
	this.valueChangedActions.push(valueChangedAction);
}
FormInputAdapter.prototype.registerActivateSubmitAction = function(activateSubmitAction)
{
	;
	this.activateSubmitActions.push(activateSubmitAction);
}
FormInputAdapter.prototype.registerDeactivateSubmitAction = function(deactivateSubmitAction)
{
	;
	this.deactivateSubmitActions.push(deactivateSubmitAction);
}
FormInputAdapter.prototype.setInitialString = function(initialString)
{
	;
	this.initialString = initialString;
	this.inputWidget.value = this.initialString;
}
FormInputAdapter.prototype.eventFromChild = function(childName, eventType, event)
{
	////;
	var domlet = this.domlets[childName];
	switch (eventType)
			{
		case "blur" :
			;
			this.blurHandler(domlet, event);
			break;
		case "keyup" :
			;
			this.keyUpHandler(domlet, event);
			break;
	}
}
FormInputAdapter.prototype.blurHandler = function(domlet, event)
{
	;
	for (var i = 0; i < this.blurActions.length; i++)
	{
		this.blurActions[i].invoke(this.inputWidget.value);
	}
}
FormInputAdapter.prototype.keyUpHandler = function(domlet, event)
{
	;
	if (event.keyCode == 13)
	{
		for (var i = 0; i < this.submitActions.length; i++)
		{
			if (this.emptyPossible)
				this.submitActions[i].invoke(this.inputWidget.value);
			else
			{
				if (this.inputWidget.value != '')
					this.submitActions[i].invoke(this.inputWidget.value);
			}
		}
	}
	
	for (var i = 0; i < this.valueChangedActions.length; i++)
	{
		if (this.emptyPossible)
			this.valueChangedActions[i].invoke(this.inputWidget.value);
		else
		{
			if (this.inputWidget.value != '')
				this.valueChangedActions[i].invoke(this.inputWidget.value);
		}
	}
	for (var i = 0; i < this.activateSubmitActions.length; i++)
	{
		if (this.inputWidget.value != '')
			this.activateSubmitActions[i].invoke();
	}
	for (var i = 0; i < this.deactivateSubmitActions.length; i++)
	{
		if (this.inputWidget.value == '')
			this.deactivateSubmitActions[i].invoke();
	}
}
FormInputAdapter.prototype.getResetInputAction = function()
{
	return new ObjectMethodAction(this, 'resetInput');
}
FormInputAdapter.prototype.resetInput = function()
{
	if (this.initialString == null)
		this.inputWidget.value = '';
	else
		this.inputWidget.value = this.initialString;
	for (var i = 0; i < this.blurActions.length; i++)
	{
		this.blurActions[i].invoke(this.inputWidget.value);
	}
}
