/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ElementInfo</DEPENDS>
    <DEPENDS>ElementIdentifierByTag</DEPENDS>
    <DEPENDS>ElementIdentifierById</DEPENDS>
    <DEPENDS>SimpleValue</DEPENDS>
    <DEPENDS>GroupValue</DEPENDS>
    <DEPENDS>DemoTracer</DEPENDS>
</DEPENDENCIES>
*/
function ClickwatcherAccessImpl()
{
	this.manager = null;
}
ClickwatcherAccessImpl.prototype.setPageId = function(pageId)
{
	
	
	window.setTimeout('ClickwatcherAccess.doSetPageId(\"' + pageId + '\")', 1);
}
ClickwatcherAccessImpl.prototype.doSetPageId = function(pageId)
{
	if (this.manager)
		this.manager.setPageId(pageId);
}
ClickwatcherAccessImpl.prototype.setManager = function(manager)
{
	this.manager = manager;
}
ClickwatcherAccess = new ClickwatcherAccessImpl();
function Clickwatcher(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
Clickwatcher.REGEXP_HOST = /(host=)([^\&]*)/;
Clickwatcher.REGEXP_PATH = /(path=)([^\&]*)/;
Clickwatcher.prototype.init = function(sId)
{
	var me = this;
	this.sId = sId;
	this.broker = null;
	this.filter = null;
	this.hostsModel = null;
	this.pathModel = null;
	this.defaultModeId = null;
	this.modes = new Array();
	this.browseMode = true;
	this.browseLocation = null;
	this.lastValidBrowseLocation = null;
	this.proxyURL = "../proxy?";
	ClickwatcherAccess.setManager(this);
	var iFrame = null;
	var pageDocument = null;
	this.browseLocationChangeing = false;
	this.iframeLoadListener = function(e)
	{
		try
		{
			me.pageDocument = me.iFrame.contentWindow.document;
			me.checkBrowsedLocation(me.pageDocument.location.href);
			var htmlElement = me.pageDocument.getElementsByTagName("BODY")[0];
			var height = htmlElement.scrollHeight;
			var width = htmlElement.scrollWidth;
			if (width == me.initialViewWidthSroll)
			{
				
				if (height > me.initialViewHeight)
				{
					
					me.viewHeight = height + me.scrollerOffSet;
					me.viewWidth = me.initialViewWidthSroll;
				}
				else
				{
					
					me.viewHeight = me.initialViewHeight;
					me.viewWidth = me.initialViewWidth;
				}
			}
			else
			{
				
				if (height > me.initialViewHeight - me.scrollerOffSet)
				{
					
					me.viewHeight = height;
					me.viewWidth = me.initialViewWidthSroll;
				}
				else
				{
					me.viewHeight = me.initialViewHeight;
					me.viewWidth = me.initialViewWidth;
				}
			}
			me.iFrame.height = me.viewHeight;
			me.iFrame.width = me.viewWidth;
		}
		catch(e)
		{
			me.browseError();
			return false;
		}
		me.lastValidBrowseLocation = me.browseLocation;
		me.pageLoaded();
		return false;
	}
}
Clickwatcher.prototype.getId = function()
{
	return this.sId;
}
Clickwatcher.prototype.setHosts = function(model)
{
	this.hostModel = model;
	this.hostModel.addModelChangeListener(new HostsChangeListener(this));
}
Clickwatcher.prototype.setPath = function(model)
{
	this.pathModel = model;
}
Clickwatcher.prototype.start = function()
{
	
	this.iFrame = Browser.getElementById('test_iframe');
	Browser.addEventListenerToDomNode(this.iFrame, Browser.eventNames.LOAD, this.iframeLoadListener);
	this.scrollerOffSet = 16;
	this.initialViewWidth = this.iFrame.width;
	this.initialViewWidthSroll = this.iFrame.width - this.scrollerOffSet;
	this.initialViewHeight = this.iFrame.height;
	
	this.modes[this.defaultModeId].setActive();
}
Clickwatcher.prototype.getPageDocument = function()
{
	return this.pageDocument;
}
Clickwatcher.prototype.getViewWidth = function()
{
	return this.iFrame.width;
}
Clickwatcher.prototype.getViewHeight = function()
{
	return this.iFrame.height;
}
Clickwatcher.prototype.setBroker = function(broker)
{
	this.broker = broker;
	broker.addBrowseModeHandle(new ObjectMethodAction(this, "setBrowseMode", true));
	broker.addAnaylseModeHandle(new ObjectMethodAction(this, "setBrowseMode", false));
	broker.addBrowseLastValidHandle(new ObjectMethodAction(this, "browseLastValid", false));
	broker.addApplyActiveModeHandle(new ObjectMethodAction(this, "applyActiveMode"));
	broker.addResetHandle(new ObjectMethodAction(this, "reset"));
}
Clickwatcher.prototype.setBrowseMode = function(browse, mode)
{
	this.browseMode = browse;
	if (browse)
		this.broker.doBrowseModeSet();
	else
		this.broker.doAnaylseModeSet();
	for (var i in this.modes)
	{
		var myMode = this.modes[i];
		if (myMode != mode)
			myMode.setBrowse(browse);
	}
}
Clickwatcher.prototype.browse = function(lastValidLocation)
{
	this.pageId = "no_id";
	
	for (var i in this.modes)
		this.modes[i].cleanModePane();
	
	this.broker.doLoadPageStarted();
	
	var iFrame = this.getPage();
	iFrame.height = this.initialViewHeight;
	iFrame.width = this.initialViewWidth;
	if (lastValidLocation != undefined)
		this.browseLocation = lastValidLocation; 
	else
		this.browseLocation = this.buildBrowseLocation();
	iFrame.src = this.browseLocation;
}
Clickwatcher.prototype.browseError = function()
{
	
	this.broker.doLoadPageFinished();
	this.broker.doLoadPageError();
}
Clickwatcher.prototype.browseLastValid = function()
{
	if (this.lastValidBrowseLocation == null)
	{
		this.filter.reset();
		this.browse();
	}
	else
	{
		this.browse(this.lastValidBrowseLocation);
	}
}
Clickwatcher.prototype.checkBrowsedLocation = function(uri)
{
	this.browseLocationChangeing = true;
	if (Clickwatcher.REGEXP_HOST.test(uri) == true)
	{
		var encodedHost = Clickwatcher.REGEXP_HOST.exec(uri)[2];
		var host = decodeURIComponent(encodedHost);
		var path = "";
		if (Clickwatcher.REGEXP_PATH.test(uri) == true)
			path = decodeURIComponent(Clickwatcher.REGEXP_PATH.exec(uri)[2]);
		host = host + path;
		var hosts = this.hostModel.getAllValues();
		var bestHostMatch = null;
		var bestHostMatchValue = null;
		var pathValue = "";
		for (var i = 0; i < hosts.length; i++)
		{
			var hostValue = hosts[i].getValue();
			if (hostValue.length <= host.length)
			{
				if (host.substring(0, hostValue.length) == hostValue)
				{
					
					if (bestHostMatch == null)
					{
						bestHostMatch = hosts[i];
						bestHostMatchValue = hostValue;
						pathValue = host.substring(hostValue.length);
					}
					else
					{
						if (hostValue.length > bestHostMatchValue.length)
						{
							bestHostMatch = hosts[i];
							bestHostMatchValue = hostValue;
							pathValue = host.substring(hostValue.length);
						}
					}
				}
			}
		}
		if (bestHostMatch != null)
		{
			if (bestHostMatch.isActive() == false)
				bestHostMatch.setActive(true);
			if (pathValue != "")
			{
				if (pathValue.substring(0, 1) == "/")
					pathValue = pathValue.substring(1);
			}
			this.pathModel.getSelectionValueByIndex(0).changeValue(pathValue);
		}
		this.browseLocation = this.buildBrowseLocation();
	}
	else
	{
		
	}
	this.browseLocationChangeing = false;
}
Clickwatcher.prototype.buildBrowseLocation = function()
{
	var filters = this.filter.getFilter();
	var host = "host=";
	var ho = "";
	var pa = "";
	for (var id in filters)
	{
		var f = filters[id];
		var submitParam = f.getSubmitParam();
		if (submitParam == "host")
		{
			var values = f.getCommandValues();
			for (var i = 0; i < values.length; i++)
			{
				ho = values[i].getValueId();
				break;
			}
		}
		else if (submitParam == "path")
		{
			var values = f.getCommandValues();
			for (var i = 0; i < values.length; i++)
			{
				pa = values[i].getValueId();
				break;
			}
		}
	}
	host = host + encodeURIComponent(ho + pa);
	return Browser.getRelativeURL(this.proxyURL + host);
}
Clickwatcher.prototype.browseLocationChanged = function()
{
	return this.browseLocation != this.buildBrowseLocation();
}
Clickwatcher.prototype.setFilterController = function(filter)
{
	this.filter = filter;
	filter.setManager(this);
}
Clickwatcher.prototype.processFilterCommand = function(command)
{
	
}
Clickwatcher.prototype.addMode = function(mode)
{
	if (this.defaultModeId == null)
		this.defaultModeId = mode.getModeId();
	this.modes[mode.getModeId()] = mode;
	mode.setManager(this);
}
Clickwatcher.prototype.modeSetActive = function(mode)
{
	for (var type in this.modes)
	{
		var otherMode = this.modes[type];
		if (otherMode.getModeId() != mode.getModeId())
		{
			otherMode.setInActive();
		}
	}
}
Clickwatcher.prototype.pageLoaded = function()
{
	
	this.broker.doLoadPageFinished();
	
	for (var type in this.modes)
		this.modes[type].reInit();
}
Clickwatcher.prototype.setPageId = function(pageId)
{
	this.pageId = pageId;
	
	for (var type in this.modes)
		this.modes[type].pageIdChanged();
}
Clickwatcher.prototype.getPageId = function()
{
	return this.pageId;
}
Clickwatcher.prototype.getPage = function()
{
	return Browser.getElementById("test_iframe");
}
Clickwatcher.prototype.getCommonCommand = function()
{
	return "";
}
Clickwatcher.prototype.aboutToLoadData = function()
{
	this.broker.doLoadDataStarted();
}
Clickwatcher.prototype.dataLoadingFinished = function()
{
	this.broker.doLoadDataFinished();
}
Clickwatcher.prototype.applyActiveMode = function()
{
	for (var m in this.modes)
	{
		if (this.modes[m].isActive())
		{
			this.modes[m].changeModeData();
			break;
		}
	}
}
Clickwatcher.prototype.reset = function()
{
	this.hostModel.reset();
	this.applyActiveMode();
}
function HostsChangeListener(clickwatcher)
{
	this.clickwatcher = clickwatcher;
}
HostsChangeListener.prototype.setSelectionModel = function(model)
{
	
}
HostsChangeListener.prototype.selectionModelChanged = function(model)
{
	if (this.clickwatcher.browseLocationChangeing == false)
		this.clickwatcher.pathModel.getSelectionValueByIndex(0).changeValue('');
}
