/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Action</DEPENDS>
    <DEPENDS>FakeWorkItemAdapter</DEPENDS>
</DEPENDENCIES>
*/
function ConversationManager(sId, fakeQeaWorkItem)
{
  if (sId) { this.init(sId, fakeQeaWorkItem); }
}
var gConversationManager = null; 
ConversationManager_getInstance = function()
{
  return gConversationManager;
}
ConversationManager.prototype.init = function(sId, fakeQeaWorkItem)
{
  ;
  this.sId = sId;
  this.bPlay = false;
  this.aConversationElements = new Array();
  this.aProgressBars = new Array();
  this.oActiveRoleInterval = null;
  this.aRoleIntervals = new Array();
  this.bRequestStop = false;
  this.oBroker =  new Broker('ConversationManagerBroker'); 
  this.oSoundBroker = null;
  this.oConversationBroker = null;
  this.workItem = fakeQeaWorkItem;
  if(this.workItem)
  {
    this.workItemAdapter = new FakeWorkItemAdapter(sId + '_wiAdapter', this.workItem);
  }
  gConversationManager = this;
}
ConversationManager.prototype.getId = function()
{
  ;
  return this.sId;
}
ConversationManager.prototype.start = function()
{
  ;
  if ( ! this.oSoundBroker )
  {
    ;
  }
  var aTempArray = new Array();
  if ( ! this.aRoleIntervals.length )
  {
    ;
  }
  while ( this.aRoleIntervals.length )
  {
    var nLowestElement = this.aRoleIntervals.length - 1;
    for ( var i = 0; i < this.aRoleIntervals.length; i++ )
    {
      if ( this.aRoleIntervals[i].nStartTime < this.aRoleIntervals[nLowestElement].nStartTime )
      {
        nLowestElement = i;
      }
    }
    var aNewArray = this.aRoleIntervals.splice(nLowestElement, 1);
    aNewArray[0].nIndex = aTempArray.length;
    aTempArray.push(aNewArray[0]);
  }
  this.aRoleIntervals = aTempArray;
}
ConversationManager.prototype.setSoundBroker = function(oSoundBroker)
{
  ;
  this.oSoundBroker = oSoundBroker;
  oSoundBroker.addSoundStartedHandle(this.getSoundStartAction());
  oSoundBroker.addRequestSoundStopHandle(this.getRequestStopStatusAction());
  oSoundBroker.addSoundStoppedHandle(this.getSoundStopAction());
  oSoundBroker.addAbsoluteIntervalReachedHandle(this.getTimeChangeAction());
}
ConversationManager.prototype.setConversationBroker = function(oConversationBroker)
{
  ;
  this.oConversationBroker = oConversationBroker;
}
ConversationManager.prototype.setBroker = function(oBroker)
{
  ;
  this.oBroker = oBroker;
}
ConversationManager.prototype.registerProgressBar = function(oProgressBar, sRoleId)
{
  ;
  if (this.aProgressBars[sRoleId] != null)
  {
    ;
  }
  else
  {
    this.aProgressBars[sRoleId] = oProgressBar;
  }
}
ConversationManager.prototype.registerConversationElement = function(oConversationElement)
{
  ;
  if (this.aConversationElements[oConversationElement.getId()] != null)
  {
    ;
  }
  else
  {
    this.aConversationElements[oConversationElement.getId()] = oConversationElement;
  }
}
ConversationManager.prototype.registerRoleInterval = function(sRoleId, nStartTime, nEndTime)
{
  ;
  function roleInterval(sRoleId, nStartTime, nEndTime)
  {
    this.sRoleId = sRoleId;
    this.nStartTime = nStartTime;
    this.nEndTime = nEndTime;
    this.nIndex = null;
  }
  var bAlreadyInArray = false;
  for ( var i = 0; i < this.aRoleIntervals.length; i++)
  {
    if ( this.aRoleIntervals[i].nStartTime == nStartTime )
    {
      bAlreadyInArray = true;
      break;
    }
  }
  if (bAlreadyInArray)
  {
    ;
  }
  else
  {
    var roleInt = new roleInterval(sRoleId, nStartTime, nEndTime);
    this.aRoleIntervals.push(roleInt);
  }
}
ConversationManager.prototype.timeChange = function(sAbsoluteTimeReached)
{
  ;
  if ( this.bPlay )
  {
    for ( var i in this.aConversationElements )
    {
      var bActive = this.aConversationElements[i].bState;
      if ( this.aConversationElements[i].nStartTime <= sAbsoluteTimeReached && this.aConversationElements[i].nEndTime >=  sAbsoluteTimeReached)
      {
        if ( ! bActive )
        {
          this.aConversationElements[i].setActive(true);
        }
      }
      else
      {
        if ( bActive )
        {
          this.aConversationElements[i].setActive(false);
        }
      }
    }
  }
  else
  {
    for ( var i in this.aConversationElements )
    {
      var bActive = this.aConversationElements[i].bState;
      if ( bActive )
      {
        this.aConversationElements[i].setActive(false);
      }
    }
  }
  if (this.aRoleIntervals.length > 0 && this.oActiveRoleInterval)
  {
    if (this.aProgressBars[this.oActiveRoleInterval.sRoleId])
    {
      this.aProgressBars[this.oActiveRoleInterval.sRoleId].setValue(sAbsoluteTimeReached);
    }
    if ( sAbsoluteTimeReached >= this.oActiveRoleInterval.nEndTime )
    {
      if (this.aProgressBars[this.oActiveRoleInterval.sRoleId])
      {
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(false);
      }
      if ( this.aRoleIntervals[this.oActiveRoleInterval.nIndex + 1] )
      {
        if ( sAbsoluteTimeReached >= this.aRoleIntervals[this.oActiveRoleInterval.nIndex+1].nStartTime )
        {
          var nMin = null;
          var nMax = null;
          this.oActiveRoleInterval = this.aRoleIntervals[this.oActiveRoleInterval.nIndex+1];
          if (this.aProgressBars[this.oActiveRoleInterval.sRoleId])
          {
            nMin = this.oActiveRoleInterval.nStartTime;
            nMax = this.oActiveRoleInterval.nEndTime;
            this.aProgressBars[this.oActiveRoleInterval.sRoleId].setMinAndMax(nMin, nMax);
            this.aProgressBars[this.oActiveRoleInterval.sRoleId].setValue(0);
            this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(true);
          }
        }
      }
    }
  }
}
ConversationManager.prototype.playNextSoundInterval = function()
{
  ;
  if ( this.bPlay  && this.aRoleIntervals.length > 0)
  {
    if ( this.aRoleIntervals[this.oActiveRoleInterval.nIndex + 1] )
    {
      var nMin = null;
      var nMax = null;
      if (this.aProgressBars[this.oActiveRoleInterval.sRoleId])
      {
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(false);
      }
      this.oActiveRoleInterval = this.aRoleIntervals[this.oActiveRoleInterval.nIndex+1];
      if (this.aProgressBars[this.oActiveRoleInterval.sRoleId])
      {
        nMin = this.oActiveRoleInterval.nStartTime;
        nMax = this.oActiveRoleInterval.nEndTime;
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setMinAndMax(nMin, nMax);
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setValue(nMin);
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(true);
      }
      this.oSoundBroker.getSetTimePositionAbsoluteAction(this.oActiveRoleInterval.nStartTime).invoke;
      this.timeChange(this.oActiveRoleInterval.nStartTime);
    }
  }
}
ConversationManager.prototype.playPreviousSoundInterval = function()
{
  ;
  if ( this.bPlay && this.aRoleIntervals.length > 0)
  {
    if ( this.oActiveRoleInterval.nIndex )
    {
      var nMin = null;
      var nMax = null;
      if (this.aProgressBars[this.oActiveRoleInterval.sRoleId])
      {
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(false);
      }
      this.oActiveRoleInterval = this.aRoleIntervals[this.oActiveRoleInterval.nIndex - 1];
      if (this.aProgressBars[this.oActiveRoleInterval.sRoleId])
      {
        nMin = this.oActiveRoleInterval.nStartTime;
        nMax = this.oActiveRoleInterval.nEndTime;
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setMinAndMax(nMin, nMax);
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setValue(0);
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(true);
      }
      this.oSoundBroker.getSetTimePositionAbsoluteAction(this.oActiveRoleInterval.nStartTime).invoke;
      this.timeChange(this.oActiveRoleInterval.nStartTime);
    }
  }
}
ConversationManager.prototype.soundStart = function()
{
  ;
  var sendTimeChangeZero = !this.bPlay;
  this.bPlay = true;
  if (this.aRoleIntervals.length > 0)
  {
    this.oActiveRoleInterval = this.aRoleIntervals[0];
    if (this.aProgressBars[this.oActiveRoleInterval.sRoleId])
    {
      nMin = this.oActiveRoleInterval.nStartTime;
      nMax = this.oActiveRoleInterval.nEndTime;
      this.aProgressBars[this.oActiveRoleInterval.sRoleId].setMinAndMax(nMin, nMax);
      this.aProgressBars[this.oActiveRoleInterval.sRoleId].setValue(0);
      this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(true);
    }
    if ( this.oConversationBroker )
    {
      this.oConversationBroker.started();
    }
   }
   if(sendTimeChangeZero)
      this.timeChange(0); 
}
ConversationManager.prototype.soundStop = function()
{
  ;
  if(this.bPlay && this.aRoleIntervals.length > 0)
  {
      this.bPlay = false;
      if ( this.bRequestStop )
      {
        this.bRequestStop = false;
        if ( this.oConversationBroker )
        {
          this.oConversationBroker.aborted();
        }
      }
      else
      {
        if ( this.oConversationBroker )
        {
          this.oConversationBroker.completed();
        }
      }
      if (this.aProgressBars[this.oActiveRoleInterval.sRoleId])
      {
        this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(false);
      }
      this.oActiveRoleInterval = null;
      this.soundStopChange();
  }
}
ConversationManager.prototype.soundStopChange = function()
{
  ;
      var nStartTime = -1;
      for ( var i in this.aConversationElements )
      {
        if (this.aConversationElements[i].bState)
        {
          this.aConversationElements[i].setActive(false);
        }
        if(nStartTime == -1)
        {
          nStartTime = this.aConversationElements[i].nStartTime;
        }
        else if(this.aConversationElements[i].nStartTime < nStartTime)
        {
          nStartTime = this.aConversationElements[i].nStartTime;
        }
      }
      for ( var i in this.aConversationElements )
      {
        if(this.aConversationElements[i].nStartTime == nStartTime)
        {
          this.aConversationElements[i].setActive(true);
          this.aConversationElements[i].setActive(false);
        }
      }
}
ConversationManager.prototype.requestStopStatus = function()
{
  ;
  this.bRequestStop = true;
}
ConversationManager.prototype.reset = function()
{
  ;
  this.bPlay = false;
  this.bRequestStop = false;
  this.oConversationBroker.aborted();
  if (this.oActiveRoleInterval && this.aProgressBars[this.oActiveRoleInterval.sRoleId])
  {
    this.aProgressBars[this.oActiveRoleInterval.sRoleId].setActive(false);
  }
  this.oActiveRoleInterval = null;
  this.soundStopChange();
}
ConversationManager.prototype.getResetAction = function()
{
  return new ObjectMethodAction(this, "reset");
}
ConversationManager.prototype.getPlayNextSoundIntervalAction = function()
{
  return new ObjectMethodAction(this, "playNextSoundInterval");
}
ConversationManager.prototype.getPlayPreviousSoundIntervalAction = function()
{
  return new ObjectMethodAction(this, "playPreviousSoundInterval");
}
ConversationManager.prototype.getSoundStartAction = function()
{
  return new ObjectMethodAction(this, "soundStart");
}
ConversationManager.prototype.getSoundStopAction = function()
{
  return new ObjectMethodAction(this, "soundStop");
}
ConversationManager.prototype.getRequestStopStatusAction = function()
{
  return new ObjectMethodAction(this, "requestStopStatus");
}
ConversationManager.prototype.getTimeChangeAction = function()
{
  return new ObjectMethodAction(this, "timeChange");
}
