/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function CrossWordsWord(sId, sQuestionButtonWidgetDomId, oQuestion, oQuestionBroker, sAnswer, nX, nY, sOrientation)
{
  if (sId) { this.init(sId, sQuestionButtonWidgetDomId, oQuestion, oQuestionBroker, sAnswer, nX, nY, sOrientation); }
}
function Orientation(bOrientationUp, bOrientationDown, bOrientationRight, bOrientationLeft)
{
  this.bOrientationUp = bOrientationUp;
  this.bOrientationDown = bOrientationDown;
  this.bOrientationRight = bOrientationRight;
  this.bOrientationLeft = bOrientationLeft;
  this.sOrientation = false;
}
CrossWordsWord.prototype.init = function(sId, sQuestionButtonWidgetDomId, oQuestion, oQuestionBroker, sAnswer, nX, nY, sOrientation)
{
  //;     
  this.sId = sId;
  this.pEndPoint = new Point(0,0);
  this.sQuestionButtonWidgetDomId = sQuestionButtonWidgetDomId;
  this.oQuestion = oQuestion;
  this.oQuestionBroker = oQuestionBroker;
  this.sAnswer = sAnswer;
  this.nX = nX;
  this.nY = nY;
  this.oManager = null;
  if (sOrientation && this.validCompassOrientation(sOrientation))
  {
    this.oOrientation = this.computeOrientationFromCompassOrientation(sOrientation, true);
    this.sOrientation = this.oOrientation.sOrientation;
    this.computeComplementOrientation();
    this.oComplementOrientation = this.computeOrientationFromCompassOrientation(this.sComplementOrientation);
  }
  this.oQuestion.registerStatusChangeListener(this);
}
CrossWordsWord.prototype.computeOrientationFromCompassOrientation = function(sOrientation)
{
  var oOrientation = new Orientation(false, false, false, false); 
  switch (sOrientation)
  {
     case 'n':
        oOrientation.bOrientationUp    = true;
        oOrientation.bOrientationDown  = false;
        oOrientation.bOrientationRight = false; 
        oOrientation.bOrientationLeft  = false;
      break;
      case 'o':
      case 'e':
        oOrientation.bOrientationUp    = false;
        oOrientation.bOrientationDown  = false;
        oOrientation.bOrientationRight = true; 
        oOrientation.bOrientationLeft  = false;
        oOrientation.sOrientation      = 'e';
      break;
      case 's':
        oOrientation.bOrientationUp    = false;
        oOrientation.bOrientationDown  = true;
        oOrientation.bOrientationRight = false; 
        oOrientation.bOrientationLeft  = false;
      break;
      case 'w':
        oOrientation.bOrientationUp    = false;
        oOrientation.bOrientationDown  = false;
        oOrientation.bOrientationRight = false; 
        oOrientation.bOrientationLeft  = true;
      break;
      case 'no':
      case 'ne':
        oOrientation.bOrientationUp    = true;
        oOrientation.bOrientationDown  = false;
        oOrientation.bOrientationRight = true; 
        oOrientation.bOrientationLeft  = false;
        oOrientation.sOrientation      = 'ne';
      break;
      case 'so':
      case 'se':
        oOrientation.bOrientationUp    = false;
        oOrientation.bOrientationDown  = true;
        oOrientation.bOrientationRight = true; 
        oOrientation.bOrientationLeft  = false;
        oOrientation.sOrientation      = 'se';
      break;
      case 'sw':
        oOrientation.bOrientationUp    = false;
        oOrientation.bOrientationDown  = true;
        oOrientation.bOrientationRight = false; 
        oOrientation.bOrientationLeft  = true;
      break;
      case 'nw':
        oOrientation.bOrientationUp    = true;
        oOrientation.bOrientationDown  = false;
        oOrientation.bOrientationRight = false; 
        oOrientation.bOrientationLeft  = true;
      break;      
  }
  if(! oOrientation.sOrientation ) 
  {
    oOrientation.sOrientation = sOrientation;
  }
  return oOrientation;
}
CrossWordsWord.prototype.validCompassOrientation = function(sOrientation)
{
  //;     
  if(sOrientation == 's' || sOrientation == 'o' || sOrientation == 'e')
  {
    return true;
  }
  else
  {
    ;
    return false;
  }
}
CrossWordsWord.prototype.getId = function()
{
  //;     
  return this.sId;
}
CrossWordsWord.prototype.getQuestionButtonWidgetDomId = function()
{
  //;     
  return this.sQuestionButtonWidgetDomId;
}
CrossWordsWord.prototype.focus = function()
{
  ;
  this.oQuestion.workItem.setUserFocus(this.oQuestion);
  this.oQuestionBroker.setFocus();
}
CrossWordsWord.prototype.blur = function()
{
  ;
  this.oQuestionBroker.blur();
}
CrossWordsWord.prototype.getQuestion = function()
{
  //;     
  return this.oQuestion;
}
CrossWordsWord.prototype.getQuestionBroker = function()
{
  //;     
  return this.oQuestionBroker;
}
CrossWordsWord.prototype.setManager = function(manager)
{
  //;     
  this.oManager = manager;
}
CrossWordsWord.prototype.getEndPoint = function()
{
  //;     
  if(this.pEndPoint.x == 0 && this.pEndPoint.y == 0)
  {
    var x = null;
    var y = null;
    var length = null;
    while ( length < this.sAnswer.length -1 )
    {
      if (this.getOrientationRight())
      {
        x++;
      }
      if (this.getOrientationLeft())
      {
        x--;
      }
        if (this.getOrientationUp())
      {
        y--;
      }
        if (this.getOrientationDown())
      {
        y++;
      }
      if(Math.abs(x))
      {
        length = Math.abs(x);
      }
      else
      {
        length = Math.abs(y);
      }
    }
    this.pEndPoint.x = this.nX + x ;
    this.pEndPoint.y = this.nY + y ;
  }  
  return new Point(this.pEndPoint.x, this.pEndPoint.y);
}
CrossWordsWord.prototype.getXPos = function()
{
  //;     
  return this.nX;
}
CrossWordsWord.prototype.getYPos = function()
{
  //;     
  return this.nY;
}
CrossWordsWord.prototype.getOrientation = function()
{
  //;     
  return this.sOrientation;
}
CrossWordsWord.prototype.getComplementOrientation = function()
{
  //;     
  return this.sComplementOrientation;
}
CrossWordsWord.prototype.computeComplementOrientation = function()
{
  //;     
  if(this.sOrientation)
  {
    switch(this.sOrientation)
    {
      case 'n':
        this.sComplementOrientation    = 's';
      break;
      case 'o':
      case 'e':
        this.sComplementOrientation = 'w'
      break;
      case 's':
        this.sComplementOrientation = 'n'
      break;
      case 'w':
        this.sComplementOrientation = 'e'
      break;
      case 'no':
      case 'ne':
        this.sComplementOrientation = 'sw';
      break;
      case 'so':
      case 'se':
        this.sComplementOrientation = 'nw'
      break;
      case 'sw':
        this.sComplementOrientation = 'ne';
      break;
      case 'nw':
        this.sComplementOrientation = 'e'
      break;      
    }
  }
}
CrossWordsWord.prototype.getOrientationUp = function()
{
  //;     
  return this.oOrientation.bOrientationUp;
}
CrossWordsWord.prototype.getOrientationDown = function()
{
  //;     
  return this.oOrientation.bOrientationDown;
}
CrossWordsWord.prototype.getOrientationRight = function()
{
  //;     
  return this.oOrientation.bOrientationRight;
}
CrossWordsWord.prototype.getOrientationLeft = function()
{
  //;     
  return this.oOrientation.bOrientationLeft;
}
CrossWordsWord.prototype.getComplementOrientationUp = function()
{
  //;     
  return this.oComplementOrientation.bOrientationUp;
}
CrossWordsWord.prototype.getComplementOrientationDown = function()
{
  //;     
  return this.oComplementOrientation.bOrientationDown;
}
CrossWordsWord.prototype.getComplementOrientationRight = function()
{
  //;     
  return this.oComplementOrientation.bOrientationRight;
}
CrossWordsWord.prototype.getComplementOrientationLeft = function()
{
  //;     
  return this.oComplementOrientation.bOrientationLeft;
}
CrossWordsWord.prototype.setModelItem = function(modelItem)
{
  ;
}
CrossWordsWord.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {
      if (this.oQuestionBroker) { this.oQuestionBroker.showCorrect(); }
    }
    else if (model.isSolved() == false)
    {
      if (this.oQuestionBroker) { this.oQuestionBroker.showWrong(); }
    }
    else
    {
    }
    if (!this.oManager.bEvaluating) {
      this.oManager.bEvaluating = true;
      this.oManager.colorizeDisplay();
    }
  } else {
    this.oManager.bEvaluating = false;
  }
}
