/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Answer</DEPENDS>
    <DEPENDS>HighlighterChar</DEPENDS>
    <DEPENDS>Evaluation</DEPENDS>
</DEPENDENCIES>
*/
function HighlighterManager(sId, sHighlighterWidgetDomId)
{
  if (sId) { this.init(sId, sHighlighterWidgetDomId); }
}
HighlighterManager.prototype.init = function(sId, sHighlighterWidgetDomId)
{
  ;   
  this.sId = sId;
  this.workItem = null;
  this.correctColor = null;
  this.wrongColor = null;
  this.tipColor = null;
  this.sBgInactiveColor = null;
  this.sFgInactiveColor = null;
  this.sBgHighlightColor = null;
  this.sFgHighlightColor = null;
  this.sBgTipColor = null;
  this.sFgTipColor = null;
  this.sBgCorrectColor = null;
  this.sFgCorrectColor = null;
  this.sBgWrongColor = null;
  this.sFgWrongColor = null;
  this.oQuestion = null;
  this.sAnswer = null;
  this.aAnswers = new Array();
  this.bSelectable = false;
  this.aHighlighterChars = new Array();
  this.oBeginnSelection = null;
  this.oEndSelection = null;
  this.sSelectableCursor = null;
  this.nLowerEndSelection = null;
  this.nUpperEndSelection = null;
  this.bListenToMouseMove = false;
  this.sHighlighterWidgetDomId = sHighlighterWidgetDomId;
  this.oHighlighterWidget = document.getElementById(sHighlighterWidgetDomId);
  if ( ! this.oHighlighterWidget )
  {
    ;
  }
  this.addMouseUpHandler();
  this.addMouseMoveHandler();
}
HighlighterManager.prototype.createSelectableSpans = function(node, counter, oAnswer)  
{
  ;
  if ( node.nodeType == 3)
  {
    var fragment = document.createElement('span');
    var text = node.data;
    aHighlighterChars = new Array();
    text = text.replace(/\n/,'').replace(/\s+/,' '); 
    for ( var i = 0; i < text.length; i++)
    {
      var span = document.createElement('span'); 
      span.id = this.sId + '_HighlighterChar_' + counter.nCount + '_' + text.charAt(i);
      var textNode = document.createTextNode(text.charAt(i));
      span.appendChild(textNode);
      fragment.appendChild(span);
      oHighlighterChar = new HighlighterChar(span.id , span.id, text.charAt(i), counter.nCount)
      this.aHighlighterChars.push(oHighlighterChar);
      if ( oAnswer )
      {
        var oTipAnswer = new HighlighterAnswer('tip_' + oAnswer.getId() + '_Pos_' + counter.nCount, 1);
        oTipAnswer.setStartPos(counter.nCount);
        oTipAnswer.setLength(1);
        var oTipEvaluation = new Evaluation('tip_' + oAnswer.getId() + '_Pos_' + counter.nCount, this.oQuestion, oTipAnswer, false, false);
        this.workItem.registerEvaluation(oTipEvaluation);
        this.workItem.registerAnswer(oTipAnswer);
        oTipAnswer.start();
        oTipEvaluation.start();
        oTipAnswer.registerStatusChangeListener(oHighlighterChar);
        oAnswer.registerStatusChangeListener(oHighlighterChar);
      }
      counter.nCount++;
    }
    node.parentNode.replaceChild(fragment, node);
  }
  else
  {
    for ( var i = 0; i < node.childNodes.length; i++ )
    {
      var oTmpAnswer = oAnswer;
      var child = node.childNodes[i];
      if ( child.id )
      {
        if( this.aAnswers[child.id] )
        {
          oTmpAnswer = this.aAnswers[child.id];
          oTmpAnswer.setStartPos(counter.nCount);
          if(Browser.getId() == 'ie')
            {
                oTmpAnswer.setLength(child.innerText.length);
            }
          else if(Browser.getId() == 'moz')
            {
                oTmpAnswer.setLength(child.textContent.length);
            }
        }
      }
      this.createSelectableSpans(node.childNodes[i], counter, oTmpAnswer);
    } 
  }
}
HighlighterManager.prototype.start = function()
{
  ;
  this.workItem.start();
  function Counter(nCount)
  {
    this.nCount = nCount;
  }
  if ( this.oQuestion && this.workItem)
  {
    for(var i in this.aAnswers)
    {
      var eval = this.workItem.getEvaluation(this.oQuestion, this.aAnswers[i]);
      if ( eval )
      {
        this.aAnswers[i].lastEvaluation = eval;
        this.oQuestion.lastEvaluation = eval;
      }
    }
  }
  else
  {
  }
  this.createSelectableSpans(this.oHighlighterWidget, new Counter(0), null)
  for( var i = 0; i < this.aHighlighterChars.length; i++)
  {
    this.aHighlighterChars[i].setManager(this);
    this.aHighlighterChars[i].start();
  }
}
HighlighterManager.prototype.mouseDownHighlighterChar = function(oHighlighterChar)
{
  ;
  if ( this.bSelectable )
  {
    if ( oHighlighterChar.isModelActive() )
    {
      oHighlighterChar.setModelInActive();
    }
    this.oBeginnSelection = oHighlighterChar;
    this.oEndSelection = null;
    this.bListenToMouseMove = true;
  }
}
HighlighterManager.prototype.mouseoverHighlighterChar = function(oHighlighterChar)
{
  ;
  this.bListenToMouseMove = false;
  if ( this.oBeginnSelection && this.bSelectable)
  {
    this.oEndSelection = oHighlighterChar;
    if ( this.oBeginnSelection && this.oBeginnSelection.nPos < oHighlighterChar.nPos)
    {
      this.nLowerEndSelection = this.oBeginnSelection.nPos ;
      this.nUpperEndSelection = oHighlighterChar.nPos ;
      if( this.oBeginnSelection.getChar() == ' ' )
      {
        this.nLowerEndSelection++;
      }
      if( oHighlighterChar.getChar() == ' ' )
      {
        this.nUpperEndSelection--;
      }
    }
    else
    {
      this.nLowerEndSelection = oHighlighterChar.nPos  ;
      this.nUpperEndSelection = this.oBeginnSelection.nPos  ;
      if( this.oBeginnSelection.getChar() == ' ' )
      {
        this.nLowerEndSelection--;
      }
      if( oHighlighterChar.getChar() == ' ' )
      {
        this.nUpperEndSelection++;
      }
    }
    if (this.oBeginnSelection )
    {
      for ( i = 0; i < this.aHighlighterChars.length; i++)
      { 
        var oElement = this.aHighlighterChars[i];
        if ( i >= this.nLowerEndSelection  && i <= this.nUpperEndSelection)
        {
          if ( oElement.isModelActive() )
          {
            oElement.setModelInActive();
          }
          oElement.setActive( true );
        }
        else
        { 
          var sActiveSource = oElement.isModelActive();
          if (sActiveSource)
          {
            switch (sActiveSource)
            {
              case 'user':
                oElement.setActive(true);
                break;
              case 'system_set':
                oElement.setTipActive(true);
                break;
            }
          }
          else
          {
            oElement.setActive(false);
          }
        }
      }
    }
  }
}
HighlighterManager.prototype.globalMouseUpHandler = function( event)
{
  ;
  this.bListenToMouseMove = false;
  if ( ( event.which == 1 || event.button == 1 ) && this.oBeginnSelection)
  {
    this.oBeginnSelection = null;
    if(this.oEndSelection)
    {
      var oAnswer = null;
      var nLength = this.nUpperEndSelection - this.nLowerEndSelection + 1;
      oAnswer = this.workItem.getAnswerByPosAndLength(this.nLowerEndSelection, nLength);
      if ( ! oAnswer )
      {
        oAnswer = new HighlighterAnswer( this.sId + '_Pos_' + this.nLowerEndSelection + '_length_' + nLength, 1);
        oAnswer.setStartPos(this.nLowerEndSelection);
        oAnswer.setLength(nLength);
        this.workItem.registerAnswer(oAnswer);
        oEvaluation = new Evaluation( this.sId + '_Pos_' + this.nLowerEndSelection + '_length_' + nLength, this.oQuestion, oAnswer, false, false);
        this.workItem.registerEvaluation(oEvaluation);      
        oAnswer.start();
        oEvaluation.start();
        for ( i = this.nLowerEndSelection; i <= this.nUpperEndSelection; i++)
        {
          oAnswer.registerStatusChangeListener(this.aHighlighterChars[i]);
        }
        oEvaluation.setActive(true);
      }
      else
      {
        var oEvaluation = this.workItem.getEvaluation(this.oQuestion, oAnswer);
        oEvaluation.setActive(!oEvaluation.isActive());
      }
    }
  }  
}
HighlighterManager.prototype.addMouseUpHandler = function()
{
 ;
  mouseUpHandlerCallback = function(event)
  {
    ;
    if ( ! event )
    {
      var event = window.event;
    }
    me.globalMouseUpHandler(event);
    return false;
  }
  var me = this;
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEUP, mouseUpHandlerCallback);
}
HighlighterManager.prototype.addMouseMoveHandler = function()
{
  ;
  mousemoveHandlerCallback = function(event)
  {
    if (me.bListenToMouseMove)
    { 
      ;
      me.mouseoverHighlighterChar(me.oBeginnSelection);
    }
    return false;
  }
  var me = this;
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEMOVE, mousemoveHandlerCallback);
}
HighlighterManager.prototype.enableSelect = function(bEnable)
{
  ;
  if ( bEnable )
  {
    this.oHighlighterWidget.style.cursor =  this.sSelectableCursor;
  }
  else
  {
    this.oHighlighterWidget.style.cursor = 'default';
  }
  this.bSelectable = bEnable;
}
HighlighterManager.prototype.getEnableSelectHandle = function()
{
    return new ObjectMethodAction(this, 'enableSelect', true);
}
HighlighterManager.prototype.getDisableSelectHandle = function()
{
    return new ObjectMethodAction(this, 'enableSelect', false);
}
HighlighterManager.prototype.getId = function()
{
  //;
  return this.sId;
}
HighlighterManager.prototype.setWorkItem = function(workItem)
{
  //;
  this.workItem = workItem;
  this.workItem.setCountDynamicAnswersWrong(true);
}
HighlighterManager.prototype.setBroker = function(oBroker)
{
  //;
  this.broker = oBroker;
}
HighlighterManager.prototype.setQuestion = function(oQuestion)
{
  //;
  this.oQuestion = oQuestion;
}
HighlighterManager.prototype.registerAnswer = function(oAnswer, domId)
{
  //;
  this.aAnswers[domId] = oAnswer;
}
HighlighterManager.prototype.setBgTipColor = function(sBgTipColor)
{
  //;
  if(sBgTipColor)
  {
    this.sBgTipColor = sBgTipColor;
  }
}
HighlighterManager.prototype.setFgTipColor = function(sFgTipColor)
{
  //;
  if(sFgTipColor)
  {
    this.sFgTipColor = sFgTipColor;
  }
}
HighlighterManager.prototype.setBgHighlightColor = function(sBgHighlightColor)
{
  //;
  if(sBgHighlightColor)
  {
    this.sBgHighlightColor = sBgHighlightColor;
  }
}
HighlighterManager.prototype.setFgHighlightColor = function(sFgHighlightColor)
{
  //;
  if(sFgHighlightColor)
  {
    this.sFgHighlightColor = sFgHighlightColor;
  }
}
HighlighterManager.prototype.setBgInactiveColor = function(sBgInactiveColor)
{
  //;
  if(sBgInactiveColor)
  {
    this.sBgInactiveColor = sBgInactiveColor;
  }
}
HighlighterManager.prototype.setFgInactiveColor = function(sFgInactiveColor)
{
  //;
  if(sFgInactiveColor)
  {
    this.sFgInactiveColor = sFgInactiveColor;
  }
}
HighlighterManager.prototype.setBgCorrectColor = function(sBgCorrectColor)
{
  if(sBgCorrectColor)
  {
    this.sBgCorrectColor = sBgCorrectColor;
  }
}
HighlighterManager.prototype.setFgCorrectColor = function(sFgCorrectColor)
{
  if(sFgCorrectColor)
  {
    this.sFgCorrectColor = sFgCorrectColor;
  }
}
HighlighterManager.prototype.setBgWrongColor = function(sBgWrongColor)
{
  if(sBgWrongColor)
  {
    this.sBgWrongColor = sBgWrongColor;
  }
}
HighlighterManager.prototype.setFgWrongColor = function(sFgWrongColor)
{
  if(sFgWrongColor)
  {
    this.sFgWrongColor = sFgWrongColor;
  }
}
HighlighterManager.prototype.setSelectableCursor = function(sSelectableCursor)
{
  //;
  if(sSelectableCursor)
  {
    this.sSelectableCursor = sSelectableCursor;
  }
}
