/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DropTarget</DEPENDS>
</DEPENDENCIES>
*/
DnDMatcherDropTarget.prototype             = new DropTarget();
DnDMatcherDropTarget.prototype.constructor = DnDMatcherDropTarget;
DnDMatcherDropTarget.superclass            = DropTarget.prototype;
function DnDMatcherDropTarget(sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY)
{
  if (sId) { this.init(sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY); }
}
DnDMatcherDropTarget.prototype.init = function(sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY)
{
  ;
  DnDMatcherDropTarget.superclass.init.call(this, sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY);
  this.modelItem = null;
  this.broker = null;
}
DnDMatcherDropTarget.prototype.setModelItem = function(modelItem)
{
  ;
  this.modelItem = modelItem;
}
DnDMatcherDropTarget.prototype.getModelItem = function()
{
  return this.modelItem;
}
DnDMatcherDropTarget.prototype.setBroker = function(broker)
{
  ;
  this.broker = broker;
}
DnDMatcherDropTarget.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {
      if (this.broker) { this.broker.showCorrect(); }
    }
    else if (model.isSolved() == false)
    {
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
  else
  {
    if (model.getEvaluation().hasOffItem())
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
          if (this.broker) { this.broker.showAssigned(); }
          break;
        case 'system_solution':
          if (this.broker) { this.broker.showSolution(); }
          break;
        case 'system_set':
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_approve':
          if (this.broker) { this.broker.showTipApproveCorrect(); }
          break;
        case 'system_brand':
          if (this.broker) { this.broker.showTipBrandWrong(); }
          break;
      }
    }
    else
    {
      var nCount = model.countActiveEvaluations();
      if (nCount == 0)
      {
        if (this.broker) { this.broker.showUnassigned(); }
      }
      else
      {
        switch (model.getEvaluation().getOrigin())
        {
          case 'user':
            if (this.broker) { this.broker.showAssigned(); }
            break;
          case 'system_solution':
            if (this.broker) { this.broker.showSolution(); }
            break;
          case 'system_set':
            if (this.broker) { this.broker.showTipAssigned(); }
            break;
          case 'system_approve':
            if (this.broker) { this.broker.showTipApproveCorrect(); }
            break;
          case 'system_brand':
            if (this.broker) { this.broker.showTipBrandWrong(); }
            break;
        }
      }
    }
  }
}
DnDMatcherDropTarget.prototype.enter = function(oDragable)
{
  ;
  if (this.broker) {  this.broker.showOver(); }
  oDragable.enter(this);
}
DnDMatcherDropTarget.prototype.leave = function(oDragable)
{
  ;
  if (this.broker) { this.broker.showOut(); }
  oDragable.leave(this);
}
DnDMatcherDropTarget.prototype.drop = function(oDragable)
{
  ;
  var bDropped = true;
  bDropped = this.modelItem.assign(this.modelItem, oDragable.modelItem);
  if (!bDropped)
  {
    ;
  }
  oDragable.drop(this, bDropped);
}
DnDMatcherDropTarget.prototype.lift = function(oDragable)
{
  ;
  var bLifted = true;
  bLifted = this.modelItem.unassign(this.modelItem, oDragable.modelItem);
  oDragable.lift(this);
}
DnDMatcherDropTarget.prototype.setShowAssignedAction = function(action)
{
  ;
  this.showAssignedAction = action;
}
DnDMatcherDropTarget.prototype.setShowUnassignedAction = function(action)
{
  ;
  this.showUnassignedAction = action;
}
DnDMatcherDropTarget.prototype.setShowTipAssignedAction = function(action)
{
  ;
  this.showTipAssignedAction = action;
}
DnDMatcherDropTarget.prototype.setShowTipApproveCorrectAction = function(action)
{
  ;
  this.showTipApproveCorrectAction = action;
}
DnDMatcherDropTarget.prototype.setShowTipBrandWrongAction = function(action)
{
  ;
  this.showTipBrandWrongAction = action;
}
DnDMatcherDropTarget.prototype.setShowCorrectAction = function(action)
{
  ;
  this.showCorrectAction = action;
}
DnDMatcherDropTarget.prototype.setShowWrongAction = function(action)
{
  ;
  this.showWrongAction = action;
}
