/*
<DEPENDENCIES>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DnDMatcherDropTarget</DEPENDS>
    <DEPENDS>SnapStrategy</DEPENDS>
</DEPENDENCIES>
*/
GapSnapStrategy.prototype             = new SnapStrategy();
GapSnapStrategy.prototype.constructor = GapSnapStrategy;
GapSnapStrategy.superclass            = SnapStrategy.prototype;
function GapSnapStrategy(sId, nSnapX, nSnapY, nDistance)
{
  if (sId) { this.init(sId, nSnapX, nSnapY, nDistance); }
}
GapSnapStrategy.prototype.init = function(sId, nSnapX, nSnapY, nDistance)
{
  ;
  GapSnapStrategy.superclass.init.call(this, sId, nSnapX, nSnapY);
  if (nDistance) {
    this.nDistance = nDistance;
  } else {
    ;
  }
}
GapSnapStrategy.prototype.snap = function(dragable)
{
  ;
  var aUsedSlots = new Array();
  var answerItem = null;
  while ((answerItem = this.dropTarget.modelItem.getNextActiveComplement(answerItem)) != null)
  {
    if (answerItem == dragable.modelItem)
    {
      ;
    }
    else
    {
      var dragableOfAnswerItem = this.dropTarget.dragnDropManager.getDragableByModel(answerItem);
      if (dragableOfAnswerItem == null)
      {
        ;
      }
      else
      {
        if (dragableOfAnswerItem.snapToken)
        {
          aUsedSlots[dragableOfAnswerItem.snapToken] = dragable;
        }
        else
        {
          ;
        }
      }
    }
  }
  for (var id in aUsedSlots) {
    ;
  }
  var nSlot = 0;
  var nMaxSlot = 300;
  var bFound = false;
  while (!bFound && nSlot < nMaxSlot)
  {
    var slotOfSlot = aUsedSlots[this.getTokenFromSlot(nSlot)];
    if (slotOfSlot)
    {
    }
    else
    {
      dragable.snapToken = this.getTokenFromSlot(nSlot);
      dragable.moveToSnapPosition(this.getPosFromSlot(nSlot));
      bFound = true;
      break;
    }
    nSlot++;
  }
  if (nSlot > nMaxSlot)
  {
    ;
  }
}
GapSnapStrategy.prototype.getTokenFromSlot = function(nSlot)
{
  return 'slot-' + nSlot;
}
GapSnapStrategy.prototype.getPosFromSlot = function(nSlot)
{
  return new Point(this.nSnapX + this.dropTarget.homePos.x + this.nDistance * nSlot, this.nSnapY + this.dropTarget.homePos.y + this.nDistance * nSlot);
}
StackedSnapStrategy.prototype             = new GapSnapStrategy();
StackedSnapStrategy.prototype.constructor = StackedSnapStrategy;
StackedSnapStrategy.superclass            = GapSnapStrategy.prototype;
function StackedSnapStrategy(sId, nSnapX, nSnapY, nDistance)
{
  if (sId) this.init(sId, nSnapX, nSnapY, nDistance);
}
StackedSnapStrategy.prototype.init = function(sId, nSnapX, nSnapY, nDistance)
{
  ;
  StackedSnapStrategy.superclass.init.call(this, sId, nSnapX, nSnapY, nDistance);
}
VerticalSnapStrategy.prototype             = new GapSnapStrategy();
VerticalSnapStrategy.prototype.constructor = VerticalSnapStrategy;
VerticalSnapStrategy.superclass            = GapSnapStrategy.prototype;
function VerticalSnapStrategy(sId, nSnapX, nSnapY, nDistance)
{
  if (sId) this.init(sId, nSnapX, nSnapY, nDistance);
}
VerticalSnapStrategy.prototype.init = function(sId, nSnapX, nSnapY, nDistance)
{
  ;
  VerticalSnapStrategy.superclass.init.call(this, sId, nSnapX, nSnapY, nDistance);
}
VerticalSnapStrategy.prototype.getPosFromSlot = function(nSlot)
{
  return new Point(this.nSnapX + this.dropTarget.homePos.x, this.nSnapY + this.dropTarget.homePos.y + this.nDistance * nSlot);
}
