/*
<DEPENDENCIES>
  <DEPENDS>Logger</DEPENDS>
  <DEPENDS>Product</DEPENDS>
</DEPENDENCIES>
*/
function ProductComparison(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
ProductComparison.prototype.init = function(sId)
{
	;
	this.sId = sId;
	this.slots = new Array();
	this.managerName = "comparison";
}
ProductComparison.prototype.getId = function()
{
	return this.sId;
}
ProductComparison.prototype.registerSlot = function(slot)
{
	if (this.slots[slot.getId()] != null)
	{
		;
	}
	else
	{
		this.slots[slot.getId()] = slot;
		slot.setManager(this);
	}
	return null;
}
ProductComparison.prototype.setMainManager = function(mainManager)
{
	;
	this.mainManager = mainManager;
}
ProductComparison.prototype.getManagerName = function()
{
	return this.managerName;
}
ProductComparison.prototype.isOwner = function(productId)
{
	var owner = false;
	for (var id in this.slots)
	{
		var slot = this.slots[id];
		if (slot.isEmpty() == false && slot.getProduct().getProductId() == productId)
			return true;
	}
}
ProductComparison.prototype.unassign = function(product)
{
 	;
	for (var id in this.slots)
	{
		var slot = this.slots[id];
		if (slot.isEmpty() == false)
		{
			if (this.mainManager.isProductAssignedToOther(this.getManagerName(), slot.getProduct().getProductId()))
			{
				slot.assign(null);
			}
		}
	}
}
ProductComparison.prototype.start = function()
{
	for (var id in this.slots)
	{
		var slot = this.slots[id];
		slot.notify();
	}
}
ProductComparison.prototype.pushProduct = function(originslot, product)
{
	;
	var assigned = false;
	for (var id in this.slots)
	{
		var slot = this.slots[id];
		if (slot != originslot)
		{
			if (slot.isEmpty())
			{
				slot.assign(product);
				assigned = true;
				break;
			}
		}
	}
	
	if (!assigned)
		this.mainManager.pushProduct(this, product);
}
