/*
<DEPENDENCIES>
  <DEPENDS>Logger</DEPENDS>
  <DEPENDS>Product</DEPENDS>
  <DEPENDS>ProductManagerMain</DEPENDS>
</DEPENDENCIES>
*/
function ProductManager(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
ProductManager.prototype.init = function(sId, managerName, numberOfEntries, offSet)
{
	;
	this.sId = sId;
	this.managerName = managerName;
	this.numberOfEntries = numberOfEntries;
	this.sortedProductIds = new Array();
	this.sortedProductIdsMap = new Array();
	
	this.allSortedProductIds = new Array();
	this.allSortedProductIdsMap = new Array();
	this.aSCListener = new Array();
	this.notifyView = false;
	this.callCounter = 0;
	this.offSet = offSet;
	this.lastLoadedIndex = 0;
	this.allLoaded = false;
	this.tempInitialProducts = new Array();
}
ProductManager.prototype.start = function()
{
	this.tempInitialProducts = null;
	this.fireChanged();
}
ProductManager.prototype.getManagerName = function()
{
	return this.managerName;
}
ProductManager.prototype.getId = function()
{
	return this.sId;
}
ProductManager.prototype.registerDnDManager = function(dndManager)
{
	this.dndManager = dndManager;
}
ProductManager.prototype.setDropTarget = function(dropTarget)
{
	this.dropTarget = dropTarget;
	dropTarget.setModelItem(this);
}
ProductManager.prototype.setBroker = function(broker)
{
	this.broker = broker;
}
ProductManager.prototype.setInitialIds = function(sortedProductIds, allSortedProductIds)
{
	this.sortedProductIds = sortedProductIds;
	for (var i in sortedProductIds)
		this.sortedProductIdsMap[sortedProductIds[i]] = sortedProductIds[i];
	this.allSortedProductIds = allSortedProductIds;
	for (var i in allSortedProductIds)
		this.allSortedProductIdsMap[allSortedProductIds[i]] = allSortedProductIds[i];
}
ProductManager.prototype.setInitialProducts = function(products)
{
	if (this.mainManager != null)
	{
		for (var i in products)
		{
			this.mainManager.addInitialProduct(products[i]);
		}
	}
	else
	{
		this.tempInitialProducts = products;
	}
	this.lastLoadedIndex = products.length;
}
ProductManager.prototype.registerFilter = function(filter)
{
	this.filter = filter;
	
	this.filter.setManager(this);
}
ProductManager.prototype.registerStatusChangeListener = function(scListener)
{
	;
	if (this.aSCListener[scListener.getId()] != null)
	{
		;
	}
	else
	{
		this.aSCListener[scListener.getId()] = scListener;
		scListener.setModelItem(this);
	}
	return null;
}
ProductManager.prototype.notify = function(state)
{
	for (var i in this.aSCListener)
	{
		this.aSCListener[i].changed(this, state);
	}
	this.fireChanged();
}
ProductManager.prototype.notifyItemChange = function(item)
{
	for (var i in this.aSCListener)
	{
		this.aSCListener[i].notifyItemChange(this, item);
	}
}
ProductManager.prototype.setMainManager = function(mainManager)
{
	;
	this.mainManager = mainManager;
	for (var i in this.tempInitialProducts)
	{
		;
		this.mainManager.addInitialProduct(this.tempInitialProducts[i]);
	}
}
ProductManager.prototype.filterByProductIds = function(productids)
{
	;
	this.changeModel(productids);
}
ProductManager.prototype.isOwner = function(productId)
{
	;
	return this.sortedProductIdsMap[productId] != null;
}
ProductManager.prototype.isInScope = function(product)
{
	;
	if (product == null)
		return false;
	return this.allSortedProductIdsMap[product.getProductId()] != null;
}
ProductManager.prototype.shouldNotifyView = function()
{
	return this.notifyView;
}
ProductManager.prototype.assign = function(product)
{
	this.numberOfEntries++;
	for (var i = 0; i < this.allSortedProductIds.length; i++)
	{
		if (this.allSortedProductIds[i] == product.getProductId())
		{
			if (i == 0)
			{
				var firstPart = new Array();
				firstPart.push(product.getProductId());
				this.sortedProductIds = firstPart.concat(this.sortedProductIds);
				break;
			}
			else if (i == this.allSortedProductIds.length - 1)
			{
				this.sortedProductIds.push(product.getProductId());
				break;
			}
			else
			{
				var j = i - 1;
				while (j > -1)
				{
					var beforeId = this.allSortedProductIds[j];
					if (!this.mainManager.isProductAssignedToOther(this.managerName, beforeId))
					{
						for (var k = 0; k < this.sortedProductIds.length; k++)
						{
							if (this.sortedProductIds[k] == beforeId)
							{
								
								var firstPart = this.sortedProductIds.slice(0, k + 1);
								firstPart.push(product.getProductId());
								var secondPart = this.sortedProductIds.slice(k + 1, this.sortedProductIds.length);
								this.sortedProductIds = firstPart.concat(secondPart);
								break;
							}
						}
						break;
					}
					j--;
				}
				break;
			}
		}
	}
	this.sortedProductIdsMap[product.getProductId()] = product.getProductId();
	this.lastLoadedIndex = 0;
	this.notify("reload");
}
ProductManager.prototype.unassign = function(product)
{
	this.numberOfEntries = this.numberOfEntries - 1;
	for (var i = 0; i < this.sortedProductIds.length; i++)
	{
		if (this.sortedProductIds[i] == product.getProductId())
		{
			if (i == 0)
			{
				this.sortedProductIds.shift();
				break;
			}
			else if (i == this.sortedProductIds.length - 1)
			{
				this.sortedProductIds.pop();
				break;
			}
			else
			{
				var firstPart = this.sortedProductIds.slice(0, i);
				var secondPart = this.sortedProductIds.slice(i + 1, this.sortedProductIds.length);
				this.sortedProductIds = firstPart.concat(secondPart);
				break;
			}
		}
	}
	this.sortedProductIdsMap[product.getProductId()] = null;
	this.lastLoadedIndex = 0;
	this.notify("reload");
}
ProductManager.prototype.getNumberOfItems = function()
{
	return this.numberOfEntries;
}
ProductManager.prototype.changeModel = function(ids, state)
{
	var sortedProductIds = new Array();
	var sortedProductIdsMap = new Array();
	var numberOfEntries = 0;
	var allSortedProductIds = new Array();
	var allSortedProductIdsMap = new Array();
	var numberOfAllEntries = 0;
	for (var i in ids)
	{
		if (!this.mainManager.isProductAssignedToOther(this.managerName, ids[i]))
		{
			sortedProductIds.push(ids[i]);
			sortedProductIdsMap[ids[i]] = ids[i];
			numberOfEntries++;
		}
		allSortedProductIds.push(ids[i]);
		allSortedProductIdsMap[ids[i]] = ids[i];
		numberOfAllEntries++;
	}
	this.numberOfEntries = numberOfEntries;
	this.sortedProductIds = sortedProductIds;
	this.sortedProductIdsMap = sortedProductIdsMap;
	this.lastLoadedIndex = 0;
	this.allSortedProductIds = allSortedProductIds;
	this.allSortedProductIdsMap = allSortedProductIdsMap;
	this.notify(state);
}
ProductManager.prototype.refresh = function()
{
	this.notify("refresh");
}
ProductManager.prototype.getProductByIndex = function(index)
{
	var productId = this.sortedProductIds[index];
	if (productId == null)
		return null;
	return this.mainManager.getProduct(productId);
}
ProductManager.prototype.getModelItems = function(startIndex, endIndex)
{
	var counter = 0;
	var productInfos = new Array();
	for (var i = startIndex; i < endIndex; i++)
	{
		productInfos[counter] = this.getModelItem(i);
		counter++;
	}
	return productInfos;
}
ProductManager.prototype.getModelItem = function(index)
{
	if (this.allLoaded == false && index + this.offSet > this.lastLoadedIndex)
	{
		
		var loadProductsIDs = new Array();
		var startIndex = this.lastLoadedIndex;
		if (this.lastLoadedIndex == 0)
			this.lastLoadedIndex + this.offSet;
		var endIndex = Math.min(this.lastLoadedIndex + this.offSet, this.numberOfEntries);
		this.lastLoadedIndex = endIndex;
		var loadCounter = 0;
		
		for (var i = startIndex; i < endIndex + 1; i++)
		{
			var product = this.getProductByIndex(i);
			if (product != null && !product.isLoaded())
			{
				loadProductsIDs[loadCounter] = product.getProductId();
				product.setLoaded();
				loadCounter++;
			}
		}
		if (endIndex + 1 == this.numberOfEntries)
			this.allLoaded = true;
		if (loadCounter > 0)
		{
			DynamicDataLoader.instance.loadProductInfos(
					new LoadProductInfoMainCallback(this, this.mainManager, this.sId + "_callback_" + this.callCounter),
					this.managerName, loadProductsIDs);
			this.callCounter++;
		}
	}
	return this.getProductByIndex(index);
}
ProductManager.prototype.fireChanged = function()
{
	if (this.broker)
		this.broker.doChanged(this.numberOfEntries);
}
ProductManager.prototype.fireAboutToLoadModelData = function()
{
	if (this.broker)
		this.broker.doAboutToLoadModelData();
}
ProductManager.prototype.fireModelDataLoaded = function(numberOfElements)
{
	if (this.broker)
		this.broker.doModelDataLoaded(numberOfElements);
}
function LoadProductInfoMainCallback(manager, mainManager, id)
{
	this.manager = manager;
	this.mainManager = mainManager;
	this.id = id;
	this.results = new Array();
}
LoadProductInfoMainCallback.prototype.productInfosLoaded = function(data)
{
	this.results = this.results.concat(data);
}
LoadProductInfoMainCallback.prototype.commit = function()
{
	try
	{
		for (var i in this.results)
		{
			var loadedProduct = this.results[i];
			var product = this.mainManager.getProduct(loadedProduct.getProductId());
			product.setProductInfo(loadedProduct);
			this.manager.notifyItemChange(product);
		}
	}
	catch(e)
	{
		alert("Error ind LoadProductInfoMainCallback: this.id =" + this.id + " message=" + e);
	}
	this.results = new Array();
}
LoadProductInfoMainCallback.prototype.getId = function()
{
	return this.id;
}
