/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function DnDProductDropTarget( sId, sWidgetDomId )
{
  if( sId )
  {
    this.init(sId, sWidgetDomId);
  }
}
DnDProductDropTarget.prototype.init = function( sId, sWidgetDomId )
{
  this.modelItem = null;
  this.broker = null;
  this.widget = Browser.getElementById(sWidgetDomId);
  this.sId = sId;
}
DnDProductDropTarget.prototype.getId = function()
{
  return this.sId;
}
DnDProductDropTarget.prototype.start = function()
{
}
DnDProductDropTarget.prototype.setManager = function( dragnDropManager )
{
  this.dragnDropManager = dragnDropManager;
  this.dragnDropManager.registerDragStartedHandle(new ObjectMethodAction(this, "checkSize"));
}
DnDProductDropTarget.prototype.checkSize = function()
{
  this.leftTopCorner = new Point(0, 0);
  Browser.getAbsPos(this.widget, this.leftTopCorner);
  this.width = this.getWidthByWidget();
  this.height = this.getHeightByWidget();
  this.right = this.leftTopCorner.x + this.width;
  this.bottom = this.leftTopCorner.y + this.height;
}
DnDProductDropTarget.prototype.getWidthByWidget = function()
{
  var actualwdith = 0;
  var node = this.widget;
  if( ! actualwdith )
  {
    actualwdith = parseInt(Browser.getComputedStyle(node, 'width'));
  }
  if( ! actualwdith )
  {
    if( node.width )
    {
      actualwdith = parseInt(node.width);
    }
  }
  if( ! actualwdith )
  {
    if( node.style.width )
    {
      actualwdith = parseInt(node.style.width);
    }
  }
  return actualwdith;
}
DnDProductDropTarget.prototype.getHeightByWidget = function()
{
  var actualheight = 0;
  var node = this.widget;
  if( ! actualheight )
  {
    actualheight = parseInt(Browser.getComputedStyle(node, 'height'));
  }
  if( ! actualheight )
  {
    if( node.height )
    {
      actualheight = parseInt(node.height);
    }
  }
  if( ! actualheight )
  {
    if( node.style.height )
    {
      actualheight = parseInt(node.style.height);
    }
  }
  return actualheight;
}
DnDProductDropTarget.prototype.hitTest = function( oDragable, nX, nY )
{
  if( this.leftTopCorner == undefined )
    return false;
  if( this.leftTopCorner.x < nX && nX < this.right && this.leftTopCorner.y < nY && nY < this.bottom )
  {
    return true;
  }
  else
  {
    return false;
  }
}
DnDProductDropTarget.prototype.setModelItem = function( modelItem )
{
  this.modelItem = modelItem;
}
DnDProductDropTarget.prototype.getModelItem = function()
{
  return this.modelItem;
}
DnDProductDropTarget.prototype.setBroker = function( broker )
{
  ;
  this.broker = broker;
}
DnDProductDropTarget.prototype.changed = function( model )
{
  ;
}
DnDProductDropTarget.prototype.notifyItemChange = function( model, item )
{
}
DnDProductDropTarget.prototype.enter = function( oDragable )
{
  ;
  if( this.broker )
  {
    this.broker.showOver();
  }
  oDragable.enter(this);
}
DnDProductDropTarget.prototype.leave = function( oDragable )
{
  if( this.broker )
  {
    this.broker.showOut();
  }
  oDragable.leave(this);
}
DnDProductDropTarget.prototype.drop = function( oDragable )
{
  var bDropped = false;
  if( this.modelItem.isInScope(oDragable.getModelItem()) )
  {
    var item = oDragable.getModelItem();
    oDragable.setModelItem(null);
    this.modelItem.assign(item);
    bDropped = true;
  }
  oDragable.drop(this, bDropped);
}
DnDProductDropTarget.prototype.lift = function( oDragable )
{
}
