/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>HandleMap</DEPENDS>
    <DEPENDS>SoundRecorderHandle</DEPENDS>
    <DEPENDS>SoundRecorder</DEPENDS>
</DEPENDENCIES>
*/
function SoundRecorderRegistryManager(id, coreRecorderHandle) {
  ;
  this.coreRecorderHandle  = coreRecorderHandle;
  this.recorderArray = new Array();
  HandleMap.instance.registerHandle(id, this);
}
SoundRecorderRegistryManager.prototype.register = function(recorder, timelimit) {
  ;
  var soundhandle= this.recorderArray.length;
  if(timelimit == undefined)
  {
     timelimit = 10000;
  }
  ;
  this.recorderArray[soundhandle] = recorder;
  try {
    if(this.coreRecorderHandle != undefined)
    {
       ;
       HandleMap.instance.sendMessage(this.coreRecorderHandle, 'registerRecorder', [soundhandle, timelimit]);
       ;
       return new SoundRecorderHandle(recorder, this.coreRecorderHandle, soundhandle);
    }
    else
      return new SoundRecorderHandle(recorder, undefined, soundhandle);
    }
      catch (e) {
         ;
  }
  return new SoundRecorderHandle(recorder, null, soundhandle);
}
SoundRecorderRegistryManager.prototype.registerServerHandle = function(recorder, handleName) {
  	;
  	this.recorderArray[handleName] = recorder;
    if(this.coreRecorderHandle != undefined)
    {
       return new SoundRecorderHandle(recorder, this.coreRecorderHandle, handleName);
    }
    else
    {
      return new SoundRecorderHandle(recorder, undefined, handleName);
    }
}
SoundRecorderRegistryManager.prototype.registerHandle = function(recorder, handleName, timelimit) {
  ;
  this.recorderArray[handleName] = recorder;
  if (timelimit == undefined)
  	timelimit = 10000;
  try {
    if(this.coreRecorderHandle != undefined)
    {
		HandleMap.instance.sendMessage(this.coreRecorderHandle, 'registerRecorder', [handleName, timelimit]);
      	return new SoundRecorderHandle(recorder, this.coreRecorderHandle, handleName);
    }
    else
      return new SoundRecorderHandle(recorder, undefined, handleName);
  }
  catch (e) {
    ;
  }
  return new SoundRecorderHandle(recorder, null, handleName);
}
SoundRecorderRegistryManager.prototype.getRecorder = function(handle) {
  return this.recorderArray[handle];
}
SoundRecorderRegistryManager.prototype.registerSound = function(soundbroker) {
  ;
  soundRecorder = new SoundRecorder(this);
  ;
  soundRecorder.setSoundBroker(soundBroker);
  return soundRecorder;
}
SoundRecorderRegistryManager.prototype.play = function(handle) {
  ;
  soundRecorder = this.recorderArray[handle];
  if (soundRecorder)
  	soundRecorder.play();
}
SoundRecorderRegistryManager.prototype.stop = function(handle) {
  ;
  soundRecorder = this.recorderArray[handle];
  if (soundRecorder)
  	soundRecorder.stop();
}
SoundRecorderRegistryManager.prototype.record = function(handle) {
  ;
  soundRecorder = this.recorderArray[handle];
  if (soundRecorder)
  	soundRecorder.record();
}
SoundRecorderRegistryManager.prototype.notifyPlaybackStart = function(handle) {
  ;
  soundRecorder = this.recorderArray[handle];
  ;
  if (soundRecorder)
    soundRecorder.soundBroker.doSoundStarted();
}
SoundRecorderRegistryManager.prototype.notifyPlaybackStop = function(handle) {
  ;
  soundRecorder = this.recorderArray[handle];
  ;
  if (soundRecorder)
  	soundRecorder.soundBroker.doSoundStopped();
}
SoundRecorderRegistryManager.prototype.notifyRecordStart = function(handle) {
  ;
  soundRecorder = this.recorderArray[handle];
  ;
  if (soundRecorder)
  	soundRecorder.soundBroker.doRecordingStarted();
}
SoundRecorderRegistryManager.prototype.notifyRecordStop = function(handle) {
  ;
  soundRecorder = this.recorderArray[handle];
  ;
  if (soundRecorder)
  	soundRecorder.soundBroker.doRecordingStopped();
}
SoundRecorderRegistryManager.prototype.notifyTimeLimitReached = function(handle) {
  ;
  soundRecorder = this.recorderArray[handle];
  ;
  if (soundRecorder)
  {
  	soundRecorder.soundBroker.doRecordingStopped();
  	soundRecorder.soundBroker.doRecordingTimeLimitReached();
  }
}
SoundRecorderRegistryManager.prototype.getResetAllAction = function() {
    return new ObjectMethodAction(this, 'resetAll');
}
SoundRecorderRegistryManager.prototype.resetAll = function() {
  	;
	HandleMap.instance.sendMessage(this.coreRecorderHandle, 'reset', []);
}
