/*
<DEPENDENCIES>
    <DEPENDS>CharacterWidget</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
WordGridCharacterWidget.prototype             = new CharacterWidget();
WordGridCharacterWidget.prototype.constructor = WordGridCharacterWidget;
WordGridCharacterWidget.superclass            = CharacterWidget.prototype;
function WordGridCharacterWidget(sId, sCharacterWidgetDomId, nX, nY, activeColor, inactiveColor, correctColor, wrongColor, tipColor)
{
  if (sId) { this.init(sId, sCharacterWidgetDomId, nX, nY, activeColor, inactiveColor, correctColor, wrongColor, tipColor); }
}
WordGridCharacterWidget.prototype.init = function(sId, sCharacterWidgetDomId, nX, nY, activeColor, inactiveColor, correctColor, wrongColor, tipColor)
{
  this.aApproveCorrectNodes = new Array();
  WordGridCharacterWidget.superclass.init.call(this, sId, sCharacterWidgetDomId, null , nX, nY, activeColor, inactiveColor, correctColor, wrongColor, tipColor);
}
WordGridCharacterWidget.prototype.setCharacter = function(sCharacter)
{
  if(sCharacter)
  {
    this.sCharacter = sCharacter;
    this.characterWidget.innerHTML = sCharacter;
  }
}
WordGridCharacterWidget.prototype.changed = function(model)
{  
  ;
  if (this.modelItem.isEvaluated())
  {      
  }
  else 
  {
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {      
      if (model.getEvaluation().getOrigin() == 'user')
      {
        this.sEvalColor = null;
      }
      this.setInactiveColor();
      this.removeAllApproveCorrect(); 
      if (this.broker) { this.broker.showUnassigned(); }
    }    
    else
    {                
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':                  
          if ( this.sEvalColor )
          {
            if ( this.sEvalColor == 'correct')
            {
              this.setCorrectColor();       
            }
            else
            {
              this.setWrongColor();
            }
          }
          else
          {
            this.setActiveColor();
          }
          break;
        case 'system_set':            
          this.setTipColor();
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_approve':          
          this.setTipColor();
          if (this.broker) { this.broker.showTipApproveCorrect(); }
          break;
        case 'system_solution':          
          this.setTipColor();
          if (this.broker) { this.broker.showSolution(); }
          break;
        case 'system_brand':  
          break;          
      }
    }
  }
}
CharacterWidget.prototype.colorizeDisplay = function(oQuestion)
{
  //;
  if ( this.modelItem )
  {
    var oEvaluation = this.modelItem.workItem.getEvaluation(oQuestion, this.modelItem);
    if (oEvaluation.isActive())
    {
      if(oEvaluation && oEvaluation.isCorrect() )
      {
        if ( oEvaluation.getOrigin() == 'user' )
        {
          this.setCorrectColor();
          this.sEvalColor = 'correct';
        }
      }
      else
      {
        this.setWrongColor();
        this.sEvalColor = 'wrong';
      }
    }
    else
    {
      this.setInactiveColor();
    }
  }
}
WordGridCharacterWidget.prototype.clickHandler = function(domlet, event)
{
  ;
  this.oCharacterWidgetManager.clickCharacterWidget(this);
}
WordGridCharacterWidget.prototype.mouseoverHandler = function(domlet, event)
{
  ;
  if( this.oCharacterWidgetManager.bMousedown )
  {
    this.oCharacterWidgetManager.clickCharacterWidget(this);
  }
}
WordGridCharacterWidget.prototype.approveCorrect = function(oWordGridWord)
{
  ;
  var bAlreadyInArray = false;
  var oImageNode = null;
  var bInverseOrientation = null;
  if (this.getXPos() ==  oWordGridWord.getXPos() && this.getYPos() == oWordGridWord.getYPos())
  {
    oImageNode = this.oCharacterWidgetManager.getCopyOfImageNode(oWordGridWord.getOrientation());
    oImageNode.id = oWordGridWord.getId();
  }
  var pEndPoint = oWordGridWord.getEndPoint();
  if (this.getXPos() ==  pEndPoint.x && this.getYPos() == pEndPoint.y)
  {
    oImageNode = this.oCharacterWidgetManager.getCopyOfImageNode(oWordGridWord.getComplementOrientation());
    oImageNode.id = oWordGridWord.getId();
    bInverseOrientation = true;
  }
  if ( oImageNode )
  {
    for(i in this.aApproveCorrectNodes)
    {
      if( this.aApproveCorrectNodes[i].id == oImageNode.id)
      {
        bAlreadyInArray = true;
      }
    }
    if ( ! bAlreadyInArray)
    {
      this.characterWidget.appendChild(oImageNode);
      this.setPosOfApproveCorrect(oImageNode, oWordGridWord, bInverseOrientation);
      this.aApproveCorrectNodes.push(oImageNode);
    }
  }
}
WordGridCharacterWidget.prototype.hideApproveCorrect = function(oWordGridWord)
{
  ;
  for(i = 0 ; i <  this.aApproveCorrectNodes.length; i++)
  {
    if( this.aApproveCorrectNodes[i].id == oWordGridWord.getId())
    {
      Browser.removeNodeFromParent(this.aApproveCorrectNodes[i]);
      break;
    }
  }
  this.aApproveCorrectNodes.splice(i,1);
}
WordGridCharacterWidget.prototype.removeAllApproveCorrect = function()
{
  ;
  for(i = 0 ; i <  this.aApproveCorrectNodes.length; i++)
  {
    Browser.removeNodeFromParent(this.aApproveCorrectNodes[i]);
  }
  this.aApproveCorrectNodes = new Array();
}
WordGridCharacterWidget.prototype.setPosOfApproveCorrect = function(oImageNode, oWordGridWord, bInverseOrientation)
{
  ;
  var up = null;
  var down = null;
  var right = null;
  var left = null;
  var nX = 0;
  var nY = 0;
  if (bInverseOrientation)
  {
    up = oWordGridWord.getComplementOrientationUp();
    down = oWordGridWord.getComplementOrientationDown();
    right = oWordGridWord.getComplementOrientationRight();
    left = oWordGridWord.getComplementOrientationLeft();
  }
  else
  {
    up = oWordGridWord.getOrientationUp();
    down = oWordGridWord.getOrientationDown();
    right = oWordGridWord.getOrientationRight();
    left = oWordGridWord.getOrientationLeft();
  }
  if ( ! up  && ! down)
  {
    nY = parseInt(this.nWidgetHeight) / 2 -  oImageNode.offsetHeight /2;
  }
  if ( !up  &&  down)
  {
    nY = 0;
  }
  if ( up  && !down)
  {
    nY = parseInt(this.nWidgetHeight) - oImageNode.offsetHeight;
  }
  if ( ! right && ! left)
  {
    nX = parseInt(this.nWidgetWidth)/ 2 -  oImageNode.offsetWidth /2;
  }
  if ( right  && ! left)
  {
    nX = 0;
  }
  if ( !right  && left)
  {
    nX = parseInt(this.nWidgetWidth) - oImageNode.offsetWidth;
  }
  oImageNode.style.position = 'absolute';
  Browser.changePixelStyle(oImageNode, 'top', nY);
  Browser.changePixelStyle(oImageNode, 'left', nX);
}
