/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>QeaWorkItem</DEPENDS>
    <DEPENDS>ExerciseHandlerStatus</DEPENDS>
</DEPENDENCIES>
*/
BingoWorkItem.prototype             = new QeaWorkItem();
BingoWorkItem.prototype.constructor = BingoWorkItem;
BingoWorkItem.superclass            = QeaWorkItem.prototype;
function BingoWorkItem(sId)
{
  if (sId) { this.init(sId); }
}
BingoWorkItem.prototype.init = function(sId)
{
  ;
  this.evaluateRequested = false;
  BingoWorkItem.superclass.init.call(this, sId);
}
BingoWorkItem.prototype.start = function()
{
  ;
  BingoWorkItem.superclass.start.call(this);
  this.nRows = 0;
  this.nCols = 0;
  for (var id in this.aAnswers)
  {
    var a = this.aAnswers[id];
    if (a.getCol && a.getRow) {
      if (a.getCol() > this.nCols) this.nCols = a.getCol();
      if (a.getRow() > this.nRows) this.nRows = a.getRow();
    }
  }
  this.nCorrect = 1;
  this.nWrong = 1;
}
BingoWorkItem.prototype.getGridStatus = function()
{
  ;
  var grid = new Array();
  {
    for (var y = 0; y < this.nRows; y++)
    {
      grid[y] = new Array();
    }
  }
  for (var id in this.aAnswers)
  {
    var a = this.aAnswers[id];
    if (a.getCol && a.getRow)
    {
      var e = this.aAnswers[id].getEvaluation();
      if (e)
      {
        if (e.isCorrect() && e.isActive()) {
          grid[a.getRow()-1][a.getCol()-1] = true;
        }
        else
        {
          grid[a.getRow()-1][a.getCol()-1] = false;
        }
      }
      else
      {
        grid[a.getRow()-1][a.getCol()-1] = undefined;
      }
    }
  }
  return grid;
}
BingoWorkItem.prototype.dumpStatus = function()
{
  ;
  var grid = this.getGridStatus();
  var sOut = '&nbsp;&nbsp;&nbsp;';
  for (var x = 0; x < this.nCols; x++)
  {
    sOut += x + '&nbsp;';
  }
  ;
  for (var y = 0; y < this.nRows; y++)
  {
    var sOut = y + ':&nbsp;';
    for (var x = 0; x < this.nCols; x++)
    {
      if (grid[y][x] == true) sOut += '+';
      else if (grid[y][x] == false) sOut += '-';
      else sOut += 'o';
      sOut += '&nbsp;';
    }
    ;
  }
  ;
}
BingoWorkItem.prototype.propagateStatus = function(evaluation)
{
  BingoWorkItem.superclass.propagateStatus.call(this, evaluation);
  var excStatus = this.getExerciseStatus();
  if(!this.bEvaluated && !this.bStopped && !this.evaluateRequested)
  {
    if ( excStatus.nCorrect == excStatus.nCorrectStatus && excStatus.nWrongStatus == 0)
    {
      this.evaluateRequested = true;
      this.evaluate();
      this.evaluateRequested = false;
    }
  }
}
BingoWorkItem.prototype.getExerciseStatus = function()
{
  ;
  var nCorrectStatus = 0;
  var nWrongStatus = 0;
  for (var id in this.aEvaluations)
  {
    var e = this.aEvaluations[id];
  }
  var grid = this.getGridStatus();
  var bSolved = false;
  {
    for (var y = 0; y < this.nRows && !bSolved; y++) {
      var bRowSolved = true;
      for (var x = 0; x < this.nCols && bRowSolved; x++) {
        bRowSolved = bRowSolved && (grid[y][x] == true);
      }
      bSolved = bSolved || bRowSolved;
    }
  }
  {
    for (var x = 0; x < this.nCols && !bSolved; x++) {
      var bColSolved = true;
      for (var y = 0; y < this.nRows && bColSolved; y++) {
        bColSolved = bColSolved && (grid[y][x] == true);
      }
      bSolved = bSolved || bColSolved;
    }
  }
  {
    for (var x = 0; x < this.nCols - this.nRows +1 && !bSolved; x++) {
      var bRightDiagSolved = true;
      for (var y = 0; y < this.nRows && bRightDiagSolved; y++) {
        bRightDiagSolved = bRightDiagSolved && (grid[y][y+x] == true);
      }
      bSolved = bSolved || bRightDiagSolved;
    }
   }
  {
    for (var x = 0; x < this.nCols - this.nRows +1 && !bSolved; x++) {
      var bLeftDiagSolved = true;
      for (var y = 0; y < this.nRows && bLeftDiagSolved; y++) {
        bLeftDiagSolved = bLeftDiagSolved && (grid[y][this.nRows-1+x-y] == true);
      }
      bSolved = bSolved || bLeftDiagSolved;
    }
  }
  if (bSolved)
  {
    nCorrectStatus = this.nCorrect;
  }
  if(this.bEvaluated)
  {
    nWrongStatus = this.nCorrect - nCorrectStatus;
  }
  return new ExerciseHandlerStatus(this.nCorrect, this.nWrong, nCorrectStatus, nWrongStatus, 0, 0, this);
}
