/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Controller</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>QeaWorkItem</DEPENDS>
</DEPENDENCIES>
*/
HangmanWorkItem.prototype             = new QeaWorkItem();
HangmanWorkItem.prototype.constructor = HangmanWorkItem;
HangmanWorkItem.superclass            = QeaWorkItem.prototype;
function HangmanWorkItem(sId) 
{
  if (sId) { this.init(sId); }
}
HangmanWorkItem.prototype.init = function(sId)
{
  ;
  this.evaluateRequested = false;
  HangmanWorkItem.superclass.init.call(this, sId);
}
HangmanWorkItem.prototype.getNumCorrect = function()
{
  return 1;
}
HangmanWorkItem.prototype.getNumWrong = function()
{
  return 1;
}
HangmanWorkItem.prototype.propagateStatus = function(evaluation)
{
  HangmanWorkItem.superclass.propagateStatus.call(this, evaluation);
  var excStatus = this.getExerciseStatus();
  if(!this.bEvaluated && !this.bStopped && !this.evaluateRequested)
  {
    if ( excStatus.nCorrect == excStatus.nCorrectStatus && excStatus.nWrongStatus == 0)
    {
      this.evaluateRequested = true;
      this.evaluate();
      this.evaluateRequested = false;
    }
  }
}
HangmanWorkItem.prototype.getExerciseStatus = function()
{
  ;
  if ( this.bCountDynamicAnswersWrong )
  {
    this.nWrong = this.nAnswers;
  }
  var nCorrectStatus = 0;
  var nWrongStatus = 0;
  var nCorrectSystem = 0;
  var nWrongSystem = 0;
  for (var id in this.aEvaluations)
  {
    var e = this.aEvaluations[id];
    if (e.isActive())
    {
      if (e.isCorrect())
      {
        if ( !e.hasOffItem() )
        {
          nCorrectStatus++;
        }
      }
      else
      {
        nWrongStatus++;
      }
    }
    else
    {
      if ( !this.bWithAlternatives && e.isCorrect() )
      {
        if ( !e.hasOffItem() )
        {
          nWrongStatus++;
        }
      }
    }
    if (e.hasSystemConstuction() || e.hasSystemPartialConstuction())
    {
      nCorrectSystem++;
    }
    if (e.hasSystemCorrection() || e.hasSystemPartialCorrection())
    {
      nWrongSystem++;
    }
  }
  nWrongStatus =  nWrongStatus > this.nWrong ? this.nWrong : nWrongStatus;
  nCorrectSystem =  nCorrectSystem ? 1 : 0;
  nWrongSystem =  nWrongSystem ? 1 : 0;
  nWrongStatus = 0;
  if((this.nCorrect != nCorrectStatus) && (this.bWorkStarted))
  {
    nWrongStatus = 1;
  }
  nCorrectStatus = this.nCorrect == nCorrectStatus ? 1 : 0;
  return new ExerciseHandlerStatus(1, 1, nCorrectStatus, nWrongStatus, nCorrectSystem, nWrongSystem, this);
}
