/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>VisibilityBroker</DEPENDS>
</DEPENDENCIES>
*/
function InformationVisibilityManager(sId)
{
  if (sId) { this.init(sId); }
}
InformationVisibilityManager.prototype.init = function(sId)
{
  this.sId = sId;
  this.nBrokers = 0;
  this.brokers = new Array();
  this.registeredInformation = new Array();
}
InformationVisibilityManager.prototype.getShowAction = function(usage)
{
  return this.findBroker(usage).getShowAction();
}
InformationVisibilityManager.prototype.registerShowHandle = function(usage, handle)
{
  this.findBroker(usage).addShowHandle(handle);
}
InformationVisibilityManager.prototype.registerInformationVisibility = function(usage, visibilityBroker)
{
  this.findBroker(usage).addShowHandle(visibilityBroker.getShowAction());
  this.findBroker(usage).addHideHandle(visibilityBroker.getHideAction());
  this.registeredInformation[usage] = true;
}
InformationVisibilityManager.prototype.getHideAction = function(usage)
{
  return this.findBroker(usage).getHideAction();
}
InformationVisibilityManager.prototype.registerHideHandle = function(usage, handle)
{
  this.findBroker(usage).addHideHandle(handle);
}
InformationVisibilityManager.prototype.getActivateAction = function(usage)
{
  return this.findBroker(usage).getActivityAction();
}
InformationVisibilityManager.prototype.registerActivateHandle = function(usage, handle)
{
  this.findBroker(usage).addActivityHandle(handle);
}
InformationVisibilityManager.prototype.findBroker = function(usage)
{
  var broker;
  if(this.brokers[usage])
  {
    broker = this.brokers[usage];
  }
  else
  {
    broker = new VisibilityBroker(this.createBrokerName());
    this.brokers[usage] = broker;
  }
  return broker;
}
InformationVisibilityManager.prototype.activateAll = function()
{
  for(var usage in this.registeredInformation)
  {
    if(this.registeredInformation[usage])
    {
      this.findBroker(usage).activity();
    }
  }
}
InformationVisibilityManager.prototype.createBrokerName = function()
{
  this.nBrokers++;
  return 'infoVisibilityBroker_' + this.nBrokers;
}
InformationVisibilityManager.prototype.start = function()
{
  this.activateAll();
}
