/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>LimitingMatcherTipStrategy</DEPENDS>
    <DEPENDS>BasicMatcherTipStrategy</DEPENDS>
</DEPENDENCIES>
*/
function BasicMatcherTipStrategy(sId)
{
  this.init(sId)
}
BasicMatcherTipStrategy.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.workItem = null;
  this.aValueItemIds = null;
}
BasicMatcherTipStrategy.prototype.getId = function()
{
  return this.sId;
}
BasicMatcherTipStrategy.prototype.setWorkItem = function(workItem)
{
  ;
  this.workItem = workItem;
}
BasicMatcherTipStrategy.prototype.start = function()
{
  ;
}
BasicMatcherTipStrategy.prototype.createValueItemIdEnumeration= function()
{
  ;
  if (this.aValueItemIds == null)
  {
    ;
    this.aValueItemIds = new Array();
    var nIndex = 0;
    for (var id in this.workItem.aValues)
    {
      this.aValueItemIds[nIndex++] = id;
    }
    shuffleArray(this.aValueItemIds);
  }
  else
  {
    ;
  }
}
BasicMatcherTipStrategy.prototype.hasTip = function(bStepByStep, bSolutable)
{
  ;
  var bHasTip = false;
  var tipItem = this.getTipItem(bStepByStep, bSolutable);
  if (tipItem != null)
  {
    bHasTip = true;
  }
  return bHasTip;
}
BasicMatcherTipStrategy.prototype.showTip = function(bStepByStep, bSolutable)
{
  ;
  var bHasTip = false;
  var tipItem = this.getTipItem(bStepByStep, bSolutable);
  if (tipItem != null)
  {
    var xNewValue = tipItem.getSolution();
    ;
    tipItem.setValueBySystem(xNewValue);
    bHasTip = true;
  }
  else
  {
    ;
  }
  return bHasTip;
}
BasicMatcherTipStrategy.prototype.getTipItem = function(bStepByStep, bSolutable)
{
  ;
  this.createValueItemIdEnumeration() 
  var tipItem = null;
  for (var i = 0; i < this.aValueItemIds.length; i++)
  {
    var valueItem = this.workItem.aValues[ this.aValueItemIds[i] ];
    ;
    if (this.checkTipItem(valueItem))
    {
      ;
      tipItem = valueItem;
      break;
    }
  }
  return tipItem;
}
BasicMatcherTipStrategy.prototype.checkTipItem = function(valueItem)
{
  ;
  return valueItem.getValue() == '' && valueItem.getSolution() != '';
}
LimitingMatcherTipStrategy.prototype             = new BasicMatcherTipStrategy();
LimitingMatcherTipStrategy.prototype.constructor = LimitingMatcherTipStrategy;
LimitingMatcherTipStrategy.superclass            = BasicMatcherTipStrategy.prototype;
function LimitingMatcherTipStrategy(sId)
{
  this.init(sId)
}
LimitingMatcherTipStrategy.prototype.init = function(sId)
{
  ;
  LimitingMatcherTipStrategy.superclass.init.call(this, sId);
}
LimitingMatcherTipStrategy.prototype.getTipItem = function(bStepByStep, bSolutable)
{
  ;
  this.createValueItemIdEnumeration() 
  var tipItem = null;
  var bSkipOne = !bSolutable;
  for (var i = 0; i < this.workItem.nValues; i++)
  {
    var valueItem = this.workItem.aValues[ this.aValueItemIds[i] ];
    ;
    if (this.checkTipItem(valueItem))
    {
      if (bSkipOne)
      {
        ;
        bSkipOne = false;
      }
      else
      {
        ;
        tipItem = valueItem;
        break;
      }
    }
  }
  return tipItem;
}
ShowMissingMatcherTipStrategy.prototype             = new LimitingMatcherTipStrategy();
ShowMissingMatcherTipStrategy.prototype.constructor = ShowMissingMatcherTipStrategy;
ShowMissingMatcherTipStrategy.superclass            = LimitingMatcherTipStrategy.prototype;
function ShowMissingMatcherTipStrategy(sId)
{
  this.init(sId)
}
ShowMissingMatcherTipStrategy.prototype.init = function(sId)
{
  ;
  ShowMissingMatcherTipStrategy.superclass.init.call(this, sId);
}
ApproveCorrectMatcherTipStrategy.prototype             = new LimitingMatcherTipStrategy();
ApproveCorrectMatcherTipStrategy.prototype.constructor = ApproveCorrectMatcherTipStrategy;
ApproveCorrectMatcherTipStrategy.superclass            = LimitingMatcherTipStrategy.prototype;
function ApproveCorrectMatcherTipStrategy(sId)
{
  this.init(sId)
}
ApproveCorrectMatcherTipStrategy.prototype.init = function(sId)
{
  ;
  ApproveCorrectMatcherTipStrategy.superclass.init.call(this, sId);
}
ApproveCorrectMatcherTipStrategy.prototype.checkTipItem = function(valueItem)
{
  ;
  return valueItem.isSolved() && valueItem.getValue() != '' && valueItem.getOrigin() != 'system' ;
}
BrandWrongMatcherTipStrategy.prototype             = new LimitingMatcherTipStrategy();
BrandWrongMatcherTipStrategy.prototype.constructor = BrandWrongMatcherTipStrategy;
BrandWrongMatcherTipStrategy.superclass            = LimitingMatcherTipStrategy.prototype;
function BrandWrongMatcherTipStrategy(sId)
{
  this.init(sId)
}
BrandWrongMatcherTipStrategy.prototype.init = function(sId)
{
  ;
  BrandWrongMatcherTipStrategy.superclass.init.call(this, sId);
}
BrandWrongMatcherTipStrategy.prototype.getTipItem = function(bStepByStep, bSolutable)
{
  ;
  this.createValueItemIdEnumeration() 
  var tipItem = null;
  var bSkipOne = !bSolutable;
  if (bSkipOne)
  {
    var nCntOptions = this.workItem.countOptions();
    var nCntCorrectAssigned = this.workItem.countCorrectAssigedValues();
    ;
    if (nCntOptions - nCntCorrectAssigned > 1)
    {
      ;
      bSkipOne = false;
    }
  }
  for (var i = 0; i < this.workItem.nValues; i++)
  {
    var valueItem = this.workItem.aValues[ this.aValueItemIds[i] ];
    ;
    if (this.checkTipItem(valueItem))
    {
      if (bSkipOne)
      {
        ;
        bSkipOne = false;
      }
      else
      {
        ;
        tipItem = valueItem;
        break;
      }
    }
  }
  return tipItem;
}
BrandWrongMatcherTipStrategy.prototype.checkTipItem = function(valueItem)
{
  ;
  return !valueItem.isSolved() && valueItem.getValue() != '' && valueItem.getOrigin() == 'user';
}
BrandWrongMatcherTipStrategy.prototype.showTip = function(bStepByStep, bSolutable)
{
  ;
  var tipItem = this.getTipItem(bStepByStep, bSolutable);
  if (tipItem != null)
  {
    var xNewValue = tipItem.getValue();
    ;
    tipItem.setValueBySystem(xNewValue);
  }
  else
  {
    ;
  }
}
