/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>QeaItem</DEPENDS>
</DEPENDENCIES>
*/
Question.prototype             = new QeaItem();
Question.prototype.constructor = Question;
Question.superclass            = QeaItem.prototype;
function Question(sId, nMax)
{
  if (sId) { this.init(sId, nMax); }
}
Question.prototype.getSameItem = function(evaluation)
{
  ;
  return evaluation.getQuestion();
}
Question.prototype.getComplementItem = function(evaluation)
{
  ;
  return evaluation.getAnswer();
}
Question.prototype.getComplementOffItem = function()
{
  //;
  return this.workItem.offAnswer;
}
Question.prototype.isOffItem = function()
{
  //;
  return this == this.workItem.offQuestion;
}
Question.prototype.activateOffEvaluation = function()
{
  ;
  var e = this.workItem.getEvaluation(this, this.workItem.offAnswer);
  if (e)
  {
    e.setActive(true, 'system_off');
  }
}
Question.prototype.getActiveAnswer = function()
{
  ;
  return this.getActiveComplement();
}
Question.prototype.evaluate = function()
{
  ;
  if (!this.bEvaluated)
  {
    ;
    if ( this.workItem.bWithAlternatives )
    {
      var nCorrectAvailable = 0;
      var nCorrectActive = 0;
      var nWrongActive = 0;
      this.bSolved = undefined;
      for (var id in this.workItem.aEvaluations)
      {
        var e = this.workItem.aEvaluations[id];
        if (this.getSameItem(e) == this)
        {
          if (e.isCorrect())
          {
            nCorrectAvailable++;
            if (e.isActive())
            {
              nCorrectActive++;
            }
          }
        }
      }
      if (nCorrectActive > 0)
      {
        this.bSolved = true;
      }
      else
      {
        if (nCorrectAvailable > 0)
        {
          this.bSolved = false;
        }
      }
      if (nCorrectAvailable == 0)
      {
        this.bSolved = true;
      }
      else
      {
        if (nCorrectActive > 0 && nCorrectActive < nCorrectAvailable)
        {
          for (var id in this.workItem.aEvaluations)
          {
            var e = this.workItem.aEvaluations[id];
            if (this.getSameItem(e) == this)
            {
              if (e.isCorrect() && !e.isActive())
              {
                if (this.getComplementItem(e).countCorrectEvaluations() <= 1)
                {
                  this.bSolved = false;
                  break;
                }
              }
            }
          }
        }
        if (nCorrectActive == 0)
        {
          var bLeftUnassigned = 0;
          for (var id in this.workItem.aEvaluations)
          {
            var e = this.workItem.aEvaluations[id];
            if (this.getSameItem(e) == this)
            {
              if (e.isCorrect())
              {
                if (this.nMax == 1)
                {
                  if (this.getComplementItem(e).countActiveCorrectEvaluations() == 0)
                  {
                    bLeftUnassigned = true;
                    break;
                  }
                }
                else
                {
                  if (this.getComplementItem(e).countActiveEvaluations() == 0)
                  {
                    bLeftUnassigned = true;
                    break;
                  }
                }
              }
            }
          }
          if (!bLeftUnassigned)
          {
            this.bSolved = undefined;
          }
        }
      }
    }
    else
    {
      var countCorrect = 0;
      this.bSolved = undefined;
      for (var id in this.workItem.aEvaluations)
      {
        var e = this.workItem.aEvaluations[id];
        if (this.getSameItem(e) == this)
        {
          if (!e.isActive() && e.isCorrect())
          {
            this.bSolved = false;
            break;
          }
          if (e.isActive() && e.isCorrect())
          {
            countCorrect++;
          }
        }
      }
      if ( this.bSolved == undefined )
      {
        if (countCorrect == this.nCorrectEvaluations )
        {
          this.bSolved = true;
        }
        else
        {
          this.bSolved = false;
        }
      }
    }      
  }
  if (this.bSolved != undefined)
  {
    this.bEvaluated = true;
    this.notify();
  }
}
Question.prototype.isQuestion = function()
{
  return true;
}
