/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
</DEPENDENCIES>
*/
MultiKnobSliderWidget.prototype = new DomletCtr();
MultiKnobSliderWidget.prototype.constructor = MultiKnobSliderWidget;
MultiKnobSliderWidget.superclass = DomletCtr.prototype;
function MultiKnobSliderWidget(sId, sSliderDomId)
{
	if (sId)
	{
		this.init(sId, sSliderDomId);
	}
}
MultiKnobSliderWidget.prototype.init = function(sId, sSliderDomId)
{
	var me = this;
	this.sId = sId;
	this.nMaxWidth = null;
	this.index = 0;
	MultiKnobSliderWidget.superclass.init.call(this, sSliderDomId, sId, null);
	this.oSlider = document.getElementById(sSliderDomId);
	this.sSliderDomId = sSliderDomId;
	this.indexChangeHandles = new Array();
	this.displaynameChangeHandles = new Array();
	if (this.oSlider == null)
	{
		;
	}
	var sliderWidth = this.getWidthByDomID(this.sSliderDomId);
	this.knobOffSet = parseInt(sliderWidth / 2);
	this.oCoverElem = this.oSlider;
	this.addDomlet(new Domlet(
			this.oCoverElem.id, 
			this.name, 
			this.parent, 
			new Array('mousedown')) 
			)
	this.mouseDownY = this.getPos().y
	
	this.mouseUpHandler = function(e)
	{
		;
		if (e)
		{
			var event = e;
		}
		Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEMOVE, me.mouseMoveHandler);
		Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEUP, me.mouseUpHandler);
		Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEOUT, me.mouseOutHandler);
		Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEDOWN, me.mouseUpHandler);
		me.getValueFromView();
	}
	this.mouseMoveHandler = function(e)
	{
		if (e)
		{
			var event = e;
		}
		if (!me.inMouseMove)
		{
			if (Math.abs(event.clientX - me.mouseDownX) > 2)
			{
				me.inMouseMove = true;
				me.beginDrag(event);
				me.lostDeltaX = event.clientX - me.mouseDownX;
			}
		}
		if (me.inMouseMove)
		{
			var nX = event.clientX - me.deltaX + me.lostDeltaX;
			;
			if (nX < me.pSliderContainerAbsPos.x)
			{
				nX = me.pSliderContainerAbsPos.x;
			}
			else
			{
				if (nX > me.pSliderContainerAbsPos.x + me.nMaxWidth)
				{
					nX = me.pSliderContainerAbsPos.x + me.nMaxWidth;
				}
			}
			me.moveTo(new Point(nX, me.mouseDownY));
		}
	}
	this.mouseOutHandler = function(event)
	{
		
		if (Browser.getId() == 'moz')
		{
			if (event.explicitOriginalTarget.nodeName == 'HTML')
			{
				me.mouseUpHandler(event);
			}
		}
		else
		{
			if (event.srcElement.tagName == 'BODY')
			{
				me.mouseUpHandler(event);
			}
		}
	}
}
MultiKnobSliderWidget.prototype.start = function()
{
}
MultiKnobSliderWidget.prototype.getKnobOffset = function()
{
	return this.knobOffSet;
}
MultiKnobSliderWidget.prototype.getId = function()
{
	return this.sId;
}
MultiKnobSliderWidget.prototype.setIndexData = function(index, displayname)
{
	this.index = index;
	this.fireIndexChanged();
	this.setDisplayName(displayname);
}
MultiKnobSliderWidget.prototype.setDisplayName = function(displayname)
{
	this.displayname = displayname;
	this.fireDisplaynameChanged();
}
MultiKnobSliderWidget.prototype.getIndex = function()
{
	return this.index;
}
MultiKnobSliderWidget.prototype.addIndexChangeHandle = function(action)
{
	this.indexChangeHandles.push(action);
}
MultiKnobSliderWidget.prototype.fireIndexChanged = function()
{
	for (var i = 0; i < this.indexChangeHandles.length; i++)
	{
		this.indexChangeHandles[i].invoke(this.index);
	}
}
MultiKnobSliderWidget.prototype.getDisplayname = function()
{
	return this.displayname;
}
MultiKnobSliderWidget.prototype.addDisplaynameChangeHandle = function(action)
{
	this.displaynameChangeHandles.push(action);
}
MultiKnobSliderWidget.prototype.fireDisplaynameChanged = function()
{
	for (var i = 0; i < this.displaynameChangeHandles.length; i++)
	{
		this.displaynameChangeHandles[i].invoke(this.displayname);
	}
}
MultiKnobSliderWidget.prototype.eventFromChild = function(childName, eventType, event)
{
	var domlet = this.domlets[childName];
	switch (eventType)
			{
		case "mousedown" :
			;
			this.mouseDownHandler(domlet, event);
			break;
		case "mouseover" :
			;
			if (this.showOverAction) this.showOverAction.invoke();
			break;
		case "mouseout" :
			;
			if (this.showOutAction) this.showOutAction.invoke();
			break;
	}
}
MultiKnobSliderWidget.prototype.mouseDownHandler = function(domlet, event)
{
	;
	this.mouseDownX = event.clientX;
	this.mouseDownY = this.getPos().y
	this.inMouseMove = false;
	Browser.setToplevel(this.oSlider);
	Browser.eventStopPropagation(event);
	Browser.eventPreventDefault(event);
	Browser.addEventListenerToDocument(Browser.eventNames.MOUSEMOVE, this.mouseMoveHandler);
	Browser.addEventListenerToDocument(Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
	Browser.addEventListenerToDocument(Browser.eventNames.MOUSEUP, this.mouseUpHandler);
	Browser.addEventListenerToDocument(Browser.eventNames.MOUSEDOWN, this.mouseUpHandler);
	return false;
}
MultiKnobSliderWidget.prototype.setController = function(controller)
{
	this.controller = controller;
}
MultiKnobSliderWidget.prototype.moveTo = function(pPoint)
{
	Browser.moveTo(this.oSlider, pPoint);
	this.controller.knobMoved(this, pPoint);
}
MultiKnobSliderWidget.prototype.getPos = function()
{
	var point = new Point(0, 0);
	Browser.getAbsPos(this.oSlider, point);
	return(point);
}
MultiKnobSliderWidget.prototype.beginDrag = function(event)
{
	this.pSliderContainerAbsPos = this.controller.getPositionOfKnobInContainer(this);
	this.nMaxWidth = this.controller.getMaxWidth(this);
	var point = this.getPos();
	this.deltaX = event.clientX - point.x;
}
MultiKnobSliderWidget.prototype.getValueFromView = function()
{
	this.controller.knobChanged(this);
}
MultiKnobSliderWidget.prototype.refreshView = function(displayname)
{
	this.pSliderContainerAbsPos = this.controller.getAbsolutePosition();
	this.nMaxWidth = this.controller.getMaxWidth(this);
	this.moveTo(new Point(this.pSliderContainerAbsPos.x + this.controller.getStartPositionOffset(this) - this.knobOffSet, this.mouseDownY));
	if (displayname != null && displayname != undefined)
		this.displayname = displayname;
	this.fireDisplaynameChanged();
}
MultiKnobSliderWidget.prototype.getWidthByDomID = function(sDomId)
{
	var actualwdith = 0;
	var node = Browser.getElementById(sDomId);
	if (! actualwdith)
	{
		actualwdith = parseInt(Browser.getComputedStyleById(sDomId, 'width'));
	}
	if (! actualwdith)
	{
		if (node.width)
		{
			actualwdith = parseInt(node.width);
		}
	}
	if (! actualwdith)
	{
		if (node.style.width)
		{
			actualwdith = parseInt(node.style.width);
		}
	}
	return actualwdith;
}
function MultiKnobSliderController(sId, sSliderContainerDomId, numberOfSteps)
{
	this.init(sId, sSliderContainerDomId, numberOfSteps);
}
MultiKnobSliderController.prototype.init = function(sId, sSliderContainerDomId, numberOfSteps)
{
	this.sId = sId;
	this.aValueChangeActions = new Array();
	this.pSliderContainerAbsPos = new Point(0, 0);
	Browser.getAbsPos(document.getElementById(sSliderContainerDomId), this.pSliderContainerAbsPos);
	this.containerWidth = parseInt(this.getWidthByDomID(sSliderContainerDomId));
	this.knobs = new Array();
	this.numberOfKnobs = 0;
	this.numberOfSteps = numberOfSteps;
	this.steps = new Array();
	this.initialIndex = new Array();
	this.changeing = false;
	this.stepWidth = this.containerWidth / (numberOfSteps - 1);
	for (var i = 0; i < numberOfSteps; i++)
	{
		this.steps[i] = this.stepWidth * i;
	}
}
MultiKnobSliderController.prototype.setSelectionModel = function(model)
{
	this.model = model;
}
MultiKnobSliderController.prototype.selectionModelChanged = function(model)
{
	if (this.changeing == false)
		this.reset();
}
MultiKnobSliderController.prototype.start = function()
{
	for (var i = 0; i < this.numberOfKnobs; i++)
	{
		var knob = this.knobs[i];
		knob.refreshView(this.model.getSelectionValueByIndex(knob.getIndex()).getValue());
	}
}
MultiKnobSliderController.prototype.getWidthByDomID = function(sDomId)
{
	var actualwdith = 0;
	var node = Browser.getElementById(sDomId);
	if (! actualwdith)
	{
		actualwdith = parseInt(Browser.getComputedStyleById(sDomId, 'width'));
	}
	if (! actualwdith)
	{
		if (node.width)
		{
			actualwdith = parseInt(node.width);
		}
	}
	if (! actualwdith)
	{
		if (node.style.width)
		{
			actualwdith = parseInt(node.style.width);
		}
	}
	return actualwdith;
}
MultiKnobSliderController.prototype.getPositionOfKnobInContainer = function(knob)
{
	var xdelta = 0;
	for (i = 0; i < this.numberOfKnobs; i++)
	{
		var aKnob = this.knobs[i];
		if (aKnob != knob)
		{
			var point = new Point(0, 0);
			Browser.getAbsPos(aKnob.oSlider, point);
			xdelta = point.x;
		}
		else
			break;
	}
	xdelta = xdelta - knob.knobOffSet;
	return new Point(parseInt(this.pSliderContainerAbsPos.x) + xdelta, parseInt(this.pSliderContainerAbsPos.y));
}
MultiKnobSliderController.prototype.getAbsolutePosition = function()
{
	return this.pSliderContainerAbsPos;
}
MultiKnobSliderController.prototype.getMaxWidth = function(knob)
{
	var firstpos = -1;
	var lastpos = -1;
	var knobY = 0;
	var myKnobIndex = 0;
	for (i = 0; i < this.numberOfKnobs; i++)
	{
		var aknob = this.knobs[i];
		if (aknob != knob)
		{
			var point = new Point(0, 0);
			Browser.getAbsPos(aknob.oSlider, point);
			if (firstpos == -1)
				firstpos = point.x + (aknob.knobOffSet * 2);
			else
				lastpos = point.x - (aknob.knobOffSet * 2);
		}
		else if (aknob == knob)
		{
			if (firstpos == -1)
				firstpos = this.pSliderContainerAbsPos.x;
		}
	}
	if (lastpos == -1)
	{
		lastpos = this.containerWidth + this.pSliderContainerAbsPos.x;
	}
	return (lastpos - firstpos);
}
MultiKnobSliderController.prototype.registerKnob = function(knob, index)
{
	this.initialIndex[this.numberOfKnobs] = index;
	this.knobs[this.numberOfKnobs] = knob;
	knob.setController(this);
	knob.setIndexData(index, '');
	this.numberOfKnobs++;
}
MultiKnobSliderController.prototype.knobChanged = function(knob)
{
	var knobInfo = this.checkPostion(knob);
	var xpos = this.pSliderContainerAbsPos.x - knob.knobOffSet + knobInfo.stepPos;
	knob.setIndexData(knobInfo.stepIndex, this.model.getSelectionValueByIndex(knobInfo.stepIndex).getValue());
	knob.moveTo(new Point(xpos, knobInfo.knobPos.y));
	this.fireValueChanged();
}
MultiKnobSliderController.prototype.knobMoved = function(knob, point)
{
	var knobInfo = this.checkPostion(knob);
	if (knob.getIndex() != knobInfo.stepIndex)
		knob.setIndexData(knobInfo.stepIndex, this.model.getSelectionValueByIndex(knobInfo.stepIndex).getValue());
}
MultiKnobSliderController.prototype.checkPostion = function(knob)
{
	var knobPos = new Point(0, 0);
	Browser.getAbsPos(knob.oSlider, knobPos)
	var stepIndex = 0;
	var stepPos = 0;
	var posx = knobPos.x - this.pSliderContainerAbsPos.x + knob.knobOffSet;
	for (var step = 0; step < this.numberOfSteps; step++)
	{
		if (posx >= this.steps[step] - (this.stepWidth / 2))
		{
			stepIndex = step;
			stepPos = this.steps[step];
		}
		else
		{
			break;
		}
	}
	var myKnobID = 0;
	for (var i = 0; i < this.numberOfKnobs; i++)
	{
		var aknob = this.knobs[i];
		if (aknob != knob)
		{
			if (aknob.getIndex() == stepIndex)
			{
				if (i > myKnobID)
				{
					stepIndex = stepIndex - 1;
					stepPos = this.steps[stepIndex];
				}
				else
				{
					stepIndex = stepIndex + 1;
					stepPos = this.steps[stepIndex];
				}
				break;
			}
		}
		else
		{
			myKnobID = i;
		}
	}
	return new SliderKnobInfo(knobPos, stepIndex, stepPos);
}
MultiKnobSliderController.prototype.getStartPositionOffset = function(knob)
{
	return this.steps[knob.getIndex()];
}
MultiKnobSliderController.prototype.fireValueChanged = function()
{
	this.changeing = true;
	if (this.model != null)
	{
		var params = new Array();
		for (var i = 0; i < this.numberOfKnobs; i++)
		{
			params[this.knobs[i].getIndex()] = this.knobs[i].getIndex();
		}
		this.model.setValuesActive(params);
	}
	this.changeing = false;
}
MultiKnobSliderController.prototype.getResetAction = function()
{
	return new ObjectMethodAction(this, "reset");
}
MultiKnobSliderController.prototype.reset = function()
{
	for (var i = 0; i < this.numberOfKnobs; i++)
	{
		var knob = this.knobs[i];
		knob.setIndexData(this.initialIndex[i], this.model.getSelectionValueByIndex(this.initialIndex[i]).getValue());
	}
	
	for (var i = 0; i < this.numberOfKnobs; i++)
	{
		var knob = this.knobs[i];
		knob.refreshView();
	}
}
function SliderKnobInfo(knobPos, stepIndex, stepPos)
{
	this.knobPos = knobPos;
	this.stepIndex = stepIndex;
	this.stepPos = stepPos;
}
