/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function StructureManager(id)
{
  	this.id = id;
  	this.structures = new Array();
	this.structuresByIndex = new Array();
	this.structureNames = new Array();
  	this.structureRoots = new Array();
	this.structureCount = 0;
}
StructureManager.prototype.start= function() {
	
	for (var i = 0; i <  this.structureNames.length; i++) {
    	var structure = this.structures[this.structureNames[i]];
    	if (structure)
    	{
    		for (var se in structure) {
    			var structureEntry = structure[se];
    			if (structureEntry && !structureEntry.getParent())
    			{
    				
    				this.structureRoots[this.structureNames[i]] = structureEntry;
    				break;
    			}
    		}
    	}
	}
}
StructureManager.prototype.addStructureEntry= function(structurename, structureEntry) {
	var structure = this.structures[structurename]; 
	var structureByIndex = this.structuresByIndex[structurename];
	if (!structure)
	{
		structure = new Array();
		this.structures[structurename] = structure;
		structureByIndex = new Array();
		this.structuresByIndex[structurename] = structureByIndex;
		this.structureNames.push(structurename);
	}
	structure[structureEntry.getContentId()] = structureEntry;
	structureByIndex[this.structureCount] = structureEntry;
	structureEntry.setIndex(this.structureCount);
	this.structureCount++;
}
StructureManager.prototype.getStructureEntry= function(structurename, cid) {
	var structure = this.structures[structurename]; 
	if (!structure)
		return null;
	else
		return (this.structures[structurename])[cid];
}
StructureManager.prototype.getRoot= function(structurename) {
	return this.structureRoots[structurename];
}
StructureManager.prototype.getStructureEntry= function(structurename, cid) {
	var structure = this.structures[structurename]; 
	if (!structure)
		return null;
	else
		return (this.structures[structurename])[cid];
}
StructureManager.prototype.getStructureEntryByIndex= function(structurename, index) {
	var structure = this.structuresByIndex[structurename]; 
	if (!structure)
		return null;
	else
		return structure[index];
}
